#include "CommMatrix.h"
#include <stdlib.h>
#include <string.h>
#include <iostream>

CommMatrix::CommMatrix(unsigned ssz, unsigned rsz)
{
  _ssz=ssz;
  _rsz=rsz;
  _mat=new long[ssz*rsz];

  std::cerr<<"[new] CommMatrix -- ssz: "<<_ssz<<"  rsz:"<<_rsz<<std::endl;
  std::cerr<<"[new] Alloc"<<(void*)_mat<<std::endl;
}

CommMatrix::CommMatrix(CommMatrix* cm)
{
  _ssz=cm->getSenderSize();
  _rsz=cm->getReceiverSize();
  _mat=new long[_ssz*_rsz];

  std::cerr<<"[new/copy] Alloc"<<(void*)_mat<<std::endl;

  long* omat= cm->_get_mat();
  memcpy(_mat, omat, sizeof(long)*_ssz*_rsz);

  std::cerr<<"[new/copy] CommMatrix -- ssz: "<<_ssz<<"  rsz:"<<_rsz<<std::endl;

}

CommMatrix::~CommMatrix()
{
  if (_mat) {
    std::cerr<<"[del] free"<<(void*)_mat<<std::endl;
    delete[] _mat;
  }
  _mat=NULL;
  std::cerr<<"[del] CommMatrix"<<std::endl;
}


void
CommMatrix::dump() const
{
  std::cerr<<"[dump] CommMatrix -- ssz: "<<_ssz<<"  rsz:"<<_rsz<<std::endl;
  for(unsigned i=0;i<_ssz;i++) {
    for(unsigned j=0;j<_rsz;j++) {
      std::cerr << "[dump] "<<i<<" -> "<<j<<" : "<<this->get(i,j)<<std::endl;
    }
  }
}
