@@NAMESPACE@@

// Example : interface foo { ... }
//
//                      foo
//                       ^
//                       |
//              PaCO_foo (Abstract class)
//              ^                    ^
//              |                    |
//    PaCO_output_stub_foo     PaCO_parallel_layer_foo

// Base class
class PaCO_@@INTERFACE_NAME@@ :
virtual public @@INTERFACE_NAME@@
{
 public:
  PaCO_@@INTERFACE_NAME@@(@@INTERFACE_NAME@@_var obj);
  virtual ~PaCO_@@INTERFACE_NAME@@() {};
  // This method permits to get the context of method "method_name"
  virtual PaCO_operation * getContext(string method_name) = 0;
  // Transform a parallel to a sequential reference
  @@INTERFACE_NAME@@_var PaCO_unarrow();
  // The client uses this method to get a pointer the server
  // If the server is parallel : return a PaCO_parallel_layer
  // If the server is sequential : return a PaCO_output_stub
  // static PaCO_@@INTERFACE_NAME@@ * get_PaCO_@@INTERFACE_NAME@@(CORBA::Object_ptr obj); 
  // static PaCO_@@INTERFACE_NAME@@ * get_PaCO_@@INTERFACE_NAME@@(CORBA::Object_ptr obj, CORBA::ORB_ptr orb);
  static PaCO_@@INTERFACE_NAME@@ * PaCO_narrow(CORBA::Object_ptr obj, CORBA::ORB_ptr orb);
@@ABSTRACT_METHODS@@
 public:
  // This attribute permits to implement PaCO_unarrow()
  @@INTERFACE_NAME@@_var _object;
  @@OBJECTS@@
};

// Stub for sequential server
class PaCO_output_stub_@@INTERFACE_NAME@@ :
virtual public PaCO_@@INTERFACE_NAME@@
{
 public:
  PaCO_output_stub_@@INTERFACE_NAME@@(@@INTERFACE_NAME@@_var obj, CORBA::ORB_ptr orb);
  ~PaCO_output_stub_@@INTERFACE_NAME@@();
  PaCO_operation * getContext(string method_name);
@@METHODS_H@@
  private:
  // Each object represent a parallel operation context
  @@INTERFACE_NAME@@_var _server;
  PaCO::PacoTopology_t serveur_topo;
};

// Parallel stub for PaCO++ server
class PaCO_parallel_layer_@@INTERFACE_NAME@@ :
virtual public PaCO_@@INTERFACE_NAME@@
{
 public:
  PaCO_parallel_layer_@@INTERFACE_NAME@@(PaCO::PacoTopology_t serveur_topo, @@INTERFACE_NAME@@_var obj, CORBA::ORB_ptr _orb);
  ~PaCO_parallel_layer_@@INTERFACE_NAME@@();
  PaCO_operation * getContext(string method_name);
  void setRealStubs(@@INTERFACE_NAME@@_PaCO_ptr* _real_stubs);
  void setRefRealStubs(int i, @@INTERFACE_NAME@@_PaCO_ptr obj);
  void setNumberStubs(int _number_stubs);

@@METHODS_H@@
 public:
  @@INTERFACE_NAME@@_PaCO_ptr * real_stubs;
  int  number_stubs;
  CORBA::ORB_ptr orb;
};

@@NAMESPACE_END@@

