# Written by Andre Ribes 2003
#!/usr/bin/env python

import sys
import os
import string
import base
import complex

def get_client_thread_dis_code(package_name, arguments, interface_name, method_name, h_src_file, configfile, modes, debug) :
    path = os.environ['PACOPATH']
    search_macro_package_name = ''
    if package_name != '':
        search_macro_package_name = '::' + package_name
    arguments_temp = arguments
    code = ''
    code = base.addFileToString(code, path + "/GenFiles/Argument/ParallelMethodClientThreadSkeleton.cc", modes)
    # Need @@NUMBER@@, @@ARGS@@, @@METHOD_NAME@@, @@METHOD_THREAD_NAME@@
    args = ''
    number = ''
    method_thread_name = ''
    
    method_thread_name = package_name + '_' + interface_name + '_' + method_name + '_client_thread'

    counter = 0
    while arguments_temp != '':
        counter = counter + 1
        arg = complex.researchArgName(arguments_temp)
        arg_type = arg.pop()
        arg_name = arg.pop()
        arguments_temp = arg.pop()

        if arg_name != '': # No Arg case
            args = args + '  args[' + str(counter) + '] = (void *) &' + arg_name + ';\n'

    number = str(counter+1)        

    code = base.string_configuration(code, '@@NUMBER@@', number)
    code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
    code = base.string_configuration(code, '@@ARGS@@', args)
    code = base.string_configuration(code, '@@METHOD_THREAD_NAME@@', method_thread_name)

    return code
# Client fonction
# asynch -> no or yes
def get_client_dis_code(package_name, arguments, interface_name, method_name, h_src_file, configfile, modes, debug, asynch='no') :

    path = os.environ['PACOPATH']
    search_macro_package_name = ''
    if package_name != '':
        search_macro_package_name = '::' + package_name
    code = ''
    arguments_temp = arguments
    distributed_arg = 'false'
    method_dist_arg_number=0
    counter = 0
    total_arg_number = 0
    while arguments_temp != '':
        counter = counter + 1
        arg = complex.researchArgName(arguments_temp)
        arg_type = arg.pop()
        arg_name = arg.pop()
        arguments_temp = arg.pop()
        macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
        type_dis_arg = base.search_macro(configfile,macro)
        if type_dis_arg == 'Distributed' :
            method_dist_arg_number = method_dist_arg_number + 1            

        if method_dist_arg_number>0:
            distributed_arg = 'true'            

    total_arg_number = counter
    if asynch == 'no': 
        modes.append('asynch_no')
    elif asynch == 'yes' :
        modes.append('asynch_yes')

    if distributed_arg == 'true' :
        code = base.addFileToString(code, path + "/GenFiles/Argument/ParallelMethodClientSkeleton.cc", modes)
        #
        # Need @@METHOD_NAME@@, @@INIT_DIS_LIB@@, @@CONS_LOCAL_COMM_MATRIX@@, @@GET_DATA@@, @@METHOD_NAME_PARALLEL@@, @@FINAL_ARGS@@, @@OUT_ARGS_INIT@@, @@CALLBACK_ARGS_INIT@@, @@@@CALLBACK_ARGS@@, @@FINAL_OUT_ARGS@@, @@FREE_ALL@@
        #

        init_dis_lib = ''
        cons_local_comm_matrix = ''
        get_data = ''
        method_name_parallel = ''
        final_args = ''
        out_args_init = ''
        callback_args = ''
        callback_args_init = ''
        final_out_args = ''
        free_all = ''
        
        method_name_parallel = method_name + '_PaCO'
        
        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()

            macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'
            macro_number = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Number'

            type_dis_arg = base.search_macro(configfile, macro)
            type_arg = base.search_macro(configfile, macro_type)
            arg_number = base.search_macro(configfile, macro_number)

            if type_dis_arg == 'Distributed' :
                if type_arg != 'out' :
                    init_dis_lib = base.addFileToString(init_dis_lib, path + "/GenFiles/Argument/InitDisLib.cc", modes)
                    # Need @@METHOD_NAME@@, @@ARG_NUMBER@@, @@ARG_NAME@@
                    init_dis_lib = base.string_configuration(init_dis_lib, '@@METHOD_NAME@@', method_name)
                    init_dis_lib = base.string_configuration(init_dis_lib, '@@ARG_NUMBER@@', arg_number)
                    init_dis_lib = base.string_configuration(init_dis_lib, '@@ARG_NAME@@', arg_name)

        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()

            macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'
            macro_number = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Number'
            
            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)
            arg_number = base.search_macro(configfile, macro_number)
            
            if type_dis_arg == 'Distributed' :
                if type_arg != 'out' :
                    cons_local_comm_matrix = base.addFileToString(cons_local_comm_matrix, path + "/GenFiles/Argument/ConsLocalCommMatrix.cc", modes)
                    # Need @@METHOD_NAME@@, @@ARG_NUMBER@@
                    cons_local_comm_matrix = base.string_configuration(cons_local_comm_matrix, '@@METHOD_NAME@@', method_name)
                    cons_local_comm_matrix = base.string_configuration(cons_local_comm_matrix, '@@ARG_NUMBER@@', arg_number)
                    
        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()

            macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'
            macro_number = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Number'
            
            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)
            arg_number = base.search_macro(configfile, macro_number)
            
            if type_dis_arg == 'Distributed' :
                if type_arg != 'out' :
		    LibDisType = base.search_macro(configfile,'ARG_DIS_TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name)
		    arg_type_to_get = base.search_macro(path + '/DistributionLibraries/Types/' + LibDisType + '.cfg', '@@ARG_TYPE@@')
		    descr_real = base.search_macro(path + '/DistributionLibraries/Types/' + LibDisType + '.cfg', '@@DESCR_REAL@@')
                    arg_type_seq = ''
                    if package_name != '':
                        arg_type_seq = base.search_macro('idl_nom', arg_type_to_get + package_name + '::' + interface_name + '_' + method_name + '_' + arg_name)
                    else :
                        arg_type_seq = base.search_macro('idl_nom', arg_type_to_get + interface_name + '_' + method_name + '_' + arg_name)

		    get_data = base.addFileToString(get_data, path + "/GenFiles/Argument/GetData.cc", modes)
                    # Need @@ARG_NAME@@, @@METHOD_NAME@@, @@ARG_NUMBER@@, @@ARG_TYPE_SEQ@@, @@DESCR_REAL@@, @@PACKAGE_NAME@@, @@INTERFACE_NAME@@
                    get_data = base.string_configuration(get_data, '@@METHOD_NAME@@', method_name)
                    get_data = base.string_configuration(get_data, '@@ARG_NAME@@', arg_name)
                    get_data = base.string_configuration(get_data, '@@ARG_TYPE_SEQ@@', arg_type_seq)
                    get_data = base.string_configuration(get_data, '@@DESCR_REAL@@', descr_real)
                    get_data = base.string_configuration(get_data, '@@ARG_NUMBER@@', arg_number)
                    get_data = base.string_configuration(get_data, '@@PACKAGE_NAME@@', package_name)
                    get_data = base.string_configuration(get_data, '@@INTERFACE_NAME@@', interface_name)

        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()

            macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'
            macro_number = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Number'
            
            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)
            arg_number = base.search_macro(configfile, macro_number)
            
            if type_dis_arg == 'Distributed' :
                if type_arg == 'in' :
                    free_all = base.addFileToString(free_all, path + "/GenFiles/Argument/FreeAll.cc", modes)
                    # Need @@ARG_TYPE@@, @@ARG_NAME@@, @@METHOD_NAME@@, @@ARG_NUMBER@@
                    free_all = base.string_configuration(free_all, '@@METHOD_NAME@@', method_name)
                    free_all = base.string_configuration(free_all, '@@ARG_NUMBER@@', arg_number)

        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()

	    macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'

            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)

            if type_arg != 'out' :
                if type_dis_arg == 'Distributed' :
                    if (final_args == '') :
                        final_args = 'distData_' + arg_name + ', *' + arg_name + '_descr'
                    else :
                        final_args = final_args + ', ' + 'distData_' + arg_name + ', *' + arg_name + '_descr'
                else :
                    if (final_args == '') :
                        final_args = arg_name
                    else :
                        final_args = final_args + ', ' + arg_name

        # Add multiple client_id
        final_args = final_args + ', global_paco_context_ptr->client_id'

        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()

	    macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'

            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)

            if type_arg == 'out' :
                # We have to add _Return_PaCO to all the types
                # defined into the interface
                index = string.find(arg_type, package_name + '::' + interface_name)
                if index != -1 :
                    arg_type = arg_type[:index + len(package_name + '::' + interface_name)] + '_Return_PaCO' + arg_type[index + len(package_name + '::' + interface_name):]
                arg_type = arg_type[:-4] # - _out
                if out_args_init == '':
                    out_args_init = arg_type + ' * ' + arg_name + '_out;\n'
                else:
                    out_args_init = out_args_init + arg_type + ' * ' + arg_name + '_out;\n'

            if type_arg == 'inout' :
                # We have to add _Return_PaCO to all the types
                # defined into the interface
                index = string.find(arg_type, package_name + '::' + interface_name)
                if index != -1 :
                    arg_type = arg_type[:index + len(package_name + '::' + interface_name)] + '_Return_PaCO' + arg_type[index + len(package_name + '::' + interface_name):]
                # arg_type = arg_type[:-4] # - _out
                if out_args_init == '':
                    out_args_init = arg_type + ' * ' + arg_name + '_out;\n'
                else:
                    out_args_init = out_args_init + arg_type + ' * ' + arg_name + '_out;\n'                    

        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()

	    macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'

            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)

            if type_arg != 'in' :
                # We have to add _Return_PaCO to all the types
                # defined into the interface
                index = string.find(arg_type, package_name + '::' + interface_name)
                if index != -1 :
                    arg_type = arg_type[:index + len(package_name + '::' + interface_name)] + '_Return_PaCO' + arg_type[index + len(package_name + '::' + interface_name):]
                arg_type = arg_type[:-4] # - _out
                if callback_args == '':
                    callback_args = '*' + arg_name + '_out'
                    callback_args_init = '&' + arg_name + '_out'
                else:
                    callback_args = callback_args + ', *' + arg_name + '_out'
                    callback_args_init = callback_args_init + ', &' + arg_name + '_out'

        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()

	    macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'

            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)

            if type_arg == 'out' :
                if final_out_args == '':
                    final_out_args = arg_name + ' = (' + arg_type[:-4] + '*)' + arg_name + '_out;\n'
                else:
                    final_out_args = final_out_args + arg_name + ' = (' + arg_type[:-4] + '*)' + arg_name + '_out;\n'

            if type_arg == 'inout' :
                if final_out_args == '':
                    final_out_args = arg_name + ' = (' + arg_type + '&)*' + arg_name + '_out;\n'
                else:
                    final_out_args = final_out_args + arg_name + ' = (' + arg_type + '&)*' + arg_name + '_out;\n'
                    
        code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
        code = base.string_configuration(code, '@@ARG_NUMBER@@', str(total_arg_number))
        code = base.string_configuration(code, '@@INIT_DIS_LIB@@', init_dis_lib)
        code = base.string_configuration(code, '@@CONS_LOCAL_COMM_MATRIX@@', cons_local_comm_matrix)
        code = base.string_configuration(code, '@@GET_DATA@@', get_data)
        code = base.string_configuration(code, '@@METHOD_NAME_PARALLEL@@', method_name_parallel)
        code = base.string_configuration(code, '@@FINAL_ARGS@@', final_args)
        code = base.string_configuration(code, '@@OUT_ARGS_INIT@@', out_args_init)
        code = base.string_configuration(code, '@@CALLBACK_ARGS_INIT@@', callback_args_init)
        code = base.string_configuration(code, '@@CALLBACK_ARGS@@', callback_args)
        code = base.string_configuration(code, '@@FINAL_OUT_ARGS@@', final_out_args)
        code = base.string_configuration(code, '@@FREE_ALL@@', free_all)                                                        
    else :

#        oneway = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_ONEWAY')
#        if oneway == 'no' :
#           if modes.count('server') == 0:
#               modes.append('no_oneway')

        if modes.count('server') == 0:
            modes.append('no_oneway')

        method_dis =  base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_ONEWAY')
        if method_dis != 'null' :
            modes.append('distributed')
        else :
            modes.append('replicated')
            
        code = base.addFileToString(code, path + "/GenFiles/Argument/ParallelMethodClientNoDisArgSkeleton.cc", modes)
        #
        # Need @@METHOD_NAME@@, @@ARGS@@, @@RETURN_INVOCATION@@, @@RETURN_INIT@@, @@RETURN_FINAL@@, @@FINAL@@
        #        
        args = ''
        return_invocation = ''
        return_init = ''
        return_final = ''
        final = ''

        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()

            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'

            type_arg = base.search_macro(configfile,macro_type)
            if arg_name != '' :
                if type_arg != 'out' :

                    # if the type is defined into the interface, we
                    # have to change the type
                    # Bad patch but usefull !
                    index = string.rfind(arg_type, "::")
                    arg_type_saved = arg_type[index:]
                    arg_type = arg_type[:index]
                    if arg_type == package_name + "::" + interface_name :
                        arg_type = package_name + "::" + interface_name + "_PaCO" + arg_type_saved
                        arg_name = "(" + arg_type + "&)" + arg_name                    
                    # patch end

                    if args == '' :
                        args = arg_name
                    else :
                        args =  args + ', ' + arg_name
                if type_arg != 'in' :
                    return_invocation = return_invocation + arg_type  + ' * '  + arg_name + '_rcp;\n'
                    final = final + arg_name + ' = *' + arg_name + '_rcp;\n'
                    if return_init == '':
                        return_init = '&' + arg_name + '_rcp'
                        return_final = arg_name
                    else :
                        return_init = return_init + ', &' + arg_name + '_rcp'
                        return_final = return_final + ', ' + arg_name

        # Multiple client patch
        client_id = 'global_paco_context_ptr->client_id'
        if args == '' :
            args = client_id
        else :
            args =  args + ', ' + client_id
        
        code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
        code = base.string_configuration(code, '@@ARGS@@', args)
        code = base.string_configuration(code, '@@RETURN_INVOCATION@@', return_invocation)
        code = base.string_configuration(code, '@@RETURN_INIT@@', return_init)
        code = base.string_configuration(code, '@@RETURN_FINAL@@', return_final)
        code = base.string_configuration(code, '@@FINAL@@', final)
##        if oneway == 'no':
##            if modes.count('server') == 0:
##                modes.remove('no_oneway')
        if modes.count('server') == 0:
            modes.remove('no_oneway')
        if method_dis != 'null' :
            modes.remove('distributed')
        else :
            modes.remove('replicated')
    if asynch == 'no' :
        modes.remove('asynch_no')
    elif asynch == 'yes':
        # If in a thread method we need :
        # @@PACKAGE_NAME@@, @@INTERFACE_NAME@@, @@ARGS_DECLARATION@@, @@OPERATION_CLASS_NAME@@, @@METHOD_NAME@@
        args_declaration = ''
        operation_class_name = ''

        operation_class_name = package_name + '::' + method_name + '_context'

        counter = 0
        arguments_temp = arguments
        while arguments_temp != '':
            counter = counter + 1
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()
            
            if arg_name != '' :
                args_declaration = args_declaration + '  ' + arg_type + ' * ' + arg_name + ' = (' + arg_type + '*) arg_rcp[' + str(counter) + '];\n'

        code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
        code = base.string_configuration(code, '@@OPERATION_CLASS_NAME@@', operation_class_name)
        code = base.string_configuration(code, '@@ARGS_DECLARATION@@', args_declaration)
        code = base.string_configuration(code, '@@INTERFACE_NAME@@', interface_name)
        code = base.string_configuration(code, '@@PACKAGE_NAME@@', package_name)
        modes.remove('asynch_yes')
    return code

# Server fonction
def get_server_dis_code(package_name, arguments, interface_name, method_name, h_src_file, configfile, orb, modes, debug) :

    path = os.environ['PACOPATH']
    search_macro_package_name = ''
    if package_name != '':
        search_macro_package_name = '::' + package_name
    code = ''
    arguments_temp = arguments
    distributed_arg = 'false'
    
    while arguments_temp != '':
        arg = complex.researchArgName(arguments_temp)
        arg_type = arg.pop()
        arg_name = arg.pop()
        arguments_temp = arg.pop()
        arg_name_search = ''
        index = string.find(arg_name, "distData_")
        if index == -1 :
            arg_name_search = arg_name
        else :
            arg_name_search = arg_name[index+9:]

        macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search

        type_dis_arg = base.search_macro(configfile,macro)

        if type_dis_arg == 'Distributed' :
            distributed_arg = 'true'
            

    if distributed_arg == 'true' :
        if modes.count('client') == 0 :
            code = base.addFileToString(code, path + "/GenFiles/Argument/ParallelMethodServerSkeleton.cc", modes)
            #
            # Need @@METHOD_NAME@@, @@GIVE_DATA@@, @@TESTS_OK@@, @@ARGS_INIT@@, @@METHOD_THREAD_NAME@@, @@ARGS_FINAL@@, @@FREE@@
            #
        else :
            code = base.addFileToString(code, path + "/GenFiles/Argument/ParallelMethodServerSkeletonReturn.cc", modes)
            #
            # Need @@METHOD_NAME@@, @@GIVE_DATA@@, @@TESTS_OK@@, @@ARGS_INIT@@, @@ARGS_FINAL@@, @@FREE@@
            #

        give_data = ''
        tests_ok = ''
        args_init = ''
        args_final = ''
        method_thread_name = ''
        free = ''

        method_thread_name = package_name + '_' + interface_name + '_' + method_name + '_thread'
        
	# We need to remove descr arguments !
	remove_descr = 'false'
	arguments_temp = arguments
	arguments = ''
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()
            arg_name_search = ''
            index = string.find(arg_name, "distData_")
            if index == -1 :
                arg_name_search = arg_name
            else :
                arg_name_search = arg_name[index+9:]

            macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search + '_Type'

            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)

	    if remove_descr == 'false' :
		if arguments == '':
		    arguments = arg_type + ' ' + arg_name
		else :
		    arguments = arguments + ', ' + arg_type + ' ' + arg_name
		if type_dis_arg == 'Distributed' :
		    remove_descr = 'true'
	    else :
		remove_descr = 'false'
		    
        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()
            arg_name_search = ''
            index = string.find(arg_name, "distData_")
            if index == -1 :
                arg_name_search = arg_name
            else :
                arg_name_search = arg_name[index+9:]

            macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search + '_Type'
            macro_number = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search + '_Number'
            
            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)
            arg_number = base.search_macro(configfile, macro_number)

            if type_dis_arg == 'Distributed' :
                if type_arg != 'out' :
                    give_data = base.addFileToString(give_data, path + "/GenFiles/Argument/GiveData.cc", modes)
                    # Need @@METHOD_NAME@@, @@ARG_NUMBER@@, @@ARG_NAME@@, @@PACKAGE_NAME@@, @@INTERFACE_NAME@@
                    give_data = base.string_configuration(give_data, '@@ARG_NAME@@', arg_name[9:])
                    give_data = base.string_configuration(give_data, '@@METHOD_NAME@@', method_name)
                    give_data = base.string_configuration(give_data, '@@ARG_NUMBER@@', arg_number)
                    give_data = base.string_configuration(give_data, '@@PACKAGE_NAME@@', package_name)
                    give_data = base.string_configuration(give_data, '@@INTERFACE_NAME@@', interface_name)

        arguments_temp = arguments
        while arguments_temp != '':
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()
            arg_name_search = ''
            index = string.find(arg_name, "distData_")
            if index == -1 :
                arg_name_search = arg_name
            else :
                arg_name_search = arg_name[index+9:]

            macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search + '_Type'

            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)

            if type_dis_arg == 'Distributed' :
                if type_arg != 'out' :
                    if tests_ok == '':
                        tests_ok = arg_name + '_ready'
                    else :
                        tests_ok = tests_ok + ' && ' + arg_name + '_ready'
                    
        arguments_temp = arguments
        counter = 0
        while arguments_temp != '':
            counter = counter + 1
            arg = complex.researchArgName(arguments_temp)
            arg_type = arg.pop()
            arg_name = arg.pop()
            arguments_temp = arg.pop()
            arg_name_search = ''
            index = string.find(arg_name, "distData_")
            if index == -1 :
                arg_name_search = arg_name
            else :
                arg_name_search = arg_name[index+9:]

            macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search
            macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search + '_Type'
            macro_number = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search + '_Number'
            
            type_dis_arg = base.search_macro(configfile,macro)
            type_arg = base.search_macro(configfile,macro_type)
            arg_number = base.search_macro(configfile, macro_number)
            
            if type_dis_arg == 'Distributed' :
                if type_arg != 'out' :
                    args_init = base.addFileToString(args_init, path + "/GenFiles/Argument/ArgsInit.cc", modes)
                    # Need @@METHOD_NAME@@, @@ARG_NUMBER@@, @@ARG_NAME@@, @@REAL_TYPE@@, @@TYPE_ARG@@
                    real_type = ''
                    LibDisType = base.search_macro(configfile,'ARG_DIS_TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search)
                    arg_type_to_get = base.search_macro(path + '/DistributionLibraries/Types/' + LibDisType + '.cfg', '@@ARG_TYPE@@')
                    if package_name != '':
                        real_type = base.search_macro('idl_nom', arg_type_to_get + package_name + '::' + interface_name + '_' + method_name + '_' + arg_name_search)
                    else:
                        real_type = base.search_macro('idl_nom', arg_type_to_get + interface_name + '_' + method_name + '_' + arg_name_search)
                        
                    type_arg = ''
                    method_class = complex.search_method(h_src_file, package_name, interface_name, orb, "CLIENT")
                    for counter2 in range(len(method_class)) :
                        result_temp = complex.decompose_method(method_class[counter2], 'c++')
                        return_method_temp    = result_temp.pop()
                        method_name_temp      = result_temp.pop()
                        arguments_method_temp = result_temp.pop()
                        if method_name_temp == method_name :
                            while arguments_method_temp != '':
                                arg_temp = complex.researchArgName(arguments_method_temp)
                                arg_type_temp = arg_temp.pop()
                                arg_name_temp = arg_temp.pop()
                                arguments_method_temp = arg_temp.pop()

                                if arg_name_temp == arg_name[9:]:
                                    index = string.find(arg_type_temp, package_name + '::' + interface_name)
                                    if index != -1 :
                                        arg_type_temp = arg_type_temp[:index + len(package_name + '::' + interface_name)] + '_PaCO' + arg_type_temp[index + len(package_name + '::' + interface_name):]
                                    type_arg = arg_type_temp

                    args_init = base.string_configuration(args_init, '@@METHOD_NAME@@', method_name)
                    args_init = base.string_configuration(args_init, '@@ARG_NUMBER@@', arg_number)
                    args_init = base.string_configuration(args_init, '@@ARG_NAME@@', arg_name)
                    args_init = base.string_configuration(args_init, '@@REAL_TYPE@@', real_type)
                    args_init = base.string_configuration(args_init, '@@TYPE_ARG@@', type_arg)
                    
        if modes.count('client') == 0 :
            args_final = base.addFileToString(args_final, path + "/GenFiles/Argument/ArgsFinal.cc", modes)
            # Need @@NUMBER@@, @@ARGS@@
            args_final = base.string_configuration(args_final, '@@NUMBER@@', str(counter+2))
            args = ''
            arguments_temp = arguments
            counter = 1
            while arguments_temp != '':
                counter = counter + 1
                arg = complex.researchArgName(arguments_temp)
                arg_type = arg.pop()
                arg_name = arg.pop()
                arguments_temp = arg.pop()
                arg_name_search = ''
                index = string.find(arg_name, "distData_")
                if index == -1 :
                    arg_name_search = arg_name
                else :
                    arg_name_search = arg_name[index+9:]
                macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search
                macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search + '_Type'
                type_dis_arg = base.search_macro(configfile,macro)
                type_arg = base.search_macro(configfile,macro_type)
                if type_dis_arg == 'Distributed' :
                    if type_arg != 'out' :
                        if args == '':
                            args = '  args[' + str(counter) + '] = (void *)' + arg_name + '_to_client;\n'
                            free = method_name + '_ptr->libraries_in[' + str(counter-1) + ']->serverFree();\n'
                        else :
                            args = args + '  args[' + str(counter) + '] = (void *)' + arg_name + '_to_client;\n'
                            free = free + '  ' + method_name + '_ptr->libraries_in[' + str(counter-1) + ']->serverFree();\n'
                    else :
                        if args == '':
                            args = '  ' + arg_type + ' *'  + arg_name + '_copy = new ' + arg_type + '(' + arg_name + ');\n'
                            args = args + '  args[' + str(counter) + '] = (void *)' + arg_name + '_copy;\n'
                        else :
                            args = args + '  ' + arg_type + ' *'  + arg_name + '_copy = new ' + arg_type + '(' + arg_name + ');\n'
                            args = args + '  args[' + str(counter) + '] = (void *)' + arg_name + '_copy;\n'
		    
            args_final = base.string_configuration(args_final, '@@ARGS@@', args)
        

        else :
            arguments_temp = arguments
            while arguments_temp != '':
                arg = complex.researchArgName(arguments_temp)
                arg_type = arg.pop()
                arg_name = arg.pop()
                arguments_temp = arg.pop()
                arg_name_search = ''
                index = string.find(arg_name, "distData_")
                if index == -1 :
                    arg_name_search = arg_name
                else :
                    arg_name_search = arg_name[index+9:]

                macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search
                macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search + '_Type'
                macro_number = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_search + '_Number'
            
                type_dis_arg = base.search_macro(configfile,macro)
                type_arg = base.search_macro(configfile,macro_type)
                arg_number = base.search_macro(configfile, macro_number)

                if type_dis_arg == 'Distributed' :
                    arg_name = '*' +  arg_name + '_to_client'
                if args_final == '':
                    args_final = arg_name
                else :
                    args_final = args_final + ', ' + arg_name
                if (arg_number != 'null') :
                    free = free + method_name + '_ptr->libraries_in[' + arg_number + ']->serverFree();\n'

        code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
        code = base.string_configuration(code, '@@GIVE_DATA@@', give_data)
        code = base.string_configuration(code, '@@TESTS_OK@@', tests_ok)
        code = base.string_configuration(code, '@@ARGS_INIT@@', args_init)
        code = base.string_configuration(code, '@@ARGS_FINAL@@', args_final)
        code = base.string_configuration(code, '@@METHOD_THREAD_NAME@@', method_thread_name)
        code = base.string_configuration(code, '@@FREE@@', free)
        
    else :

        oneway = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_ONEWAY')        
        if oneway == 'no' :
            modes.append('no_oneway')

        if modes.count('client') == 0 :
            code = base.addFileToString(code, path + "/GenFiles/Argument/ParallelMethodServerNoDisArgSkeleton.cc", modes)
            #
            # Need @@METHOD_NAME@@, @@ARG_FINALS@@, @@METHOD_THREAD_NAME@@
            #        
            args_final = ''
            method_thread_name = ''

            method_thread_name = package_name + '_' + interface_name + '_' + method_name + '_thread'
            
            args_final = base.addFileToString(args_final, path + "/GenFiles/Argument/ArgsFinal.cc", modes)
            # Need @@ARGS@@, @@NUMBER@@
            args =  ''
            arguments_temp = arguments
            counter = 1
            while arguments_temp != '':
                arg = complex.researchArgName(arguments_temp)
                arg_type = arg.pop()
                arg_name = arg.pop()
                arguments_temp = arg.pop()

                if arg_name != '': # No Arg case
                    counter = counter + 1
                    args = args + arg_type + ' * ' + arg_name + '_rcp = new ' + arg_type + '(' + arg_name + ');\n'
                    args = args + '  args[' + str(counter) + '] = (void *)' + arg_name + '_rcp;\n'
                
            args_final = base.string_configuration(args_final, '@@ARGS@@', args)
            args_final = base.string_configuration(args_final, '@@NUMBER@@', str(counter+2))

            code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
            code = base.string_configuration(code, '@@ARGS_FINAL@@', args_final)
            code = base.string_configuration(code, '@@METHOD_THREAD_NAME@@', method_thread_name)
        else :
            code = base.addFileToString(code, path + "/GenFiles/Argument/ParallelMethodServerNoDisArgSkeletonReturn.cc", modes)
            #
            # Need @@METHOD_NAME@@, @@ARGS@@
            #        
            args = ''

            arguments_temp = arguments
            while arguments_temp != '':
                arg = complex.researchArgName(arguments_temp)
                arg_type = arg.pop()
                arg_name = arg.pop()
                arguments_temp = arg.pop()

                if arg_name != '': # No Arg case
                    if args == '' :
                        args = arg_name
                    else :
                        args = args + ', ' + arg_name
                
            code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
            code = base.string_configuration(code, '@@ARGS@@', args)
        if oneway == 'no':
            modes.remove('no_oneway')
    return code
        
# Server fonction
def get_server_thread_dis_code(package_name, arguments, interface_name, method_name, h_src_file, configfile, orb, modes, debug) :

    path = os.environ['PACOPATH']
    search_macro_package_name = ''
    if package_name != '':
        search_macro_package_name = '::' + package_name
    code = ''
    arguments_temp = arguments

    if method_name[-5:] == '_PaCO' :
        method_name = method_name[:-5]
#    oneway = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_ONEWAY')
#    if oneway == 'no' :
#        modes.append('no_oneway')

    modes.append('no_oneway')
        
    code = base.addFileToString(code, path + "/GenFiles/Argument/ParallelMethodServerSkeletonThread.cc", modes)
    # Need @@PACKAGE_NAME@@,  @@INTERFACE_NAME@@, @@METHOD_NAME@@, @@ARGS@@, @@FREE@@, @@RETURN_CODE_INIT@@, @@RETURN_ARGS@@, @@OUT_ARGS_DECLARATION@@
    args = ''
    free = ''
    return_code_init = ''
    return_args = ''
    out_args_declaration = ''
    
    method_class = complex.search_method(h_src_file, package_name, interface_name, orb, "CLIENT")
    for counter2 in range(len(method_class)) :
        result_temp = complex.decompose_method(method_class[counter2], 'c++')
        return_method_temp    = result_temp.pop()
        method_name_temp      = result_temp.pop()
        arguments_method_temp = result_temp.pop()
        if method_name_temp == method_name :
            arg_number = 1
            while arguments_method_temp != '':
                arg_temp = complex.researchArgName(arguments_method_temp)
                arg_type_temp = arg_temp.pop()
                arg_name_temp = arg_temp.pop()
                arguments_method_temp = arg_temp.pop()

                arg_type_temp_temp = ''
                arg_type_temp_temp_return = ''
                
                if arg_name_temp != '':
                    macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_temp
                    macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name_temp + '_Type'
                    type_dis_arg = base.search_macro(configfile,macro)
                    type_arg = base.search_macro(configfile,macro_type)
                    if type_arg == 'in' :
                        arg_number = arg_number + 1
                        index = string.find(arg_type_temp, package_name + '::' + interface_name)
                        if index != -1 :
                            arg_type_temp = arg_type_temp[:index + len(package_name + '::' + interface_name)] + '_PaCO' + arg_type_temp[index + len(package_name + '::' + interface_name):]		    		    			
                        if args == '' :
                            args = '*(' + arg_type_temp + ' * )' +'arg_rcp[' + str(arg_number) + ']'
                        else :
                            args = args + ', *(' + arg_type_temp + ' * )' +'arg_rcp[' + str(arg_number) + ']'
                        if type_dis_arg == 'Distributed' :
                            free = free + 'cxt->libraries_in[' + str(arg_number-2) + ']->serverFree();\n'
                        else :
                            free = free + 'delete (' + arg_type_temp + ' * )arg_rcp[' + str(arg_number) + '];\n'
                        
                    elif type_arg == 'out' :
                        index = string.find(arg_type_temp, package_name + '::' + interface_name)
                        if index != -1 :
                            arg_type_temp_temp = arg_type_temp[:index + len(package_name + '::' + interface_name)] + '_PaCO' + arg_type_temp[index + len(package_name + '::' + interface_name):]
                            arg_type_temp_temp_return = arg_type_temp[:index + len(package_name + '::' + interface_name)] + '_Return' + arg_type_temp[index + len(package_name + '::' + interface_name):]
                        else:
                            arg_type_temp_temp = arg_type_temp
                            arg_type_temp_temp_return = arg_type_temp

                        index = string.find(arg_type_temp_temp, '_out')
                        if arg_type_temp_temp[:-4] == arg_type_temp_temp[:index]:
                            arg_type_temp_temp = arg_type_temp_temp[:-4]
                            arg_type_temp_temp_return = arg_type_temp_temp_return[:-4]
                            
                        if type_dis_arg == 'Distributed' :
                            out_args_declaration = out_args_declaration + arg_type_temp_temp + ' * ' + arg_name_temp + '_out;\n'
                            if args == '' :
                                args = arg_name_temp + '_out'
                            else :
                                args = args + ', ' + arg_name_temp + '_out'
                            if return_args == '':
                                return_args = '*(' + arg_type_temp_temp_return + ' *)' + arg_name_temp + '_out'
                            else :
                                return_args = return_args + ', *(' + arg_type_temp_temp_return + ' *)' + arg_name_temp + '_out'
                        else :
                            out_args_declaration = out_args_declaration + arg_type_temp_temp + ' * ' + arg_name_temp + '_out =  new ' + arg_type_temp_temp + '();\n'
                            if args == '' :
                                args = '*' + arg_name_temp + '_out'
                            else :
                                args = args + ', *' + arg_name_temp + '_out'
                            if return_args == '':
                                return_args = '*(' + arg_type_temp_temp + ' *)' + arg_name_temp + '_out'
                            else :
                                return_args = return_args + ', *(' + arg_type_temp_temp + ' *)' + arg_name_temp + '_out'
                        free = free + 'delete ' + arg_name_temp + '_out;\n'

                    elif type_arg == 'inout':
                        arg_number = arg_number + 1
                        index = string.find(arg_type_temp, package_name + '::' + interface_name)
                        if index != -1 :
                            arg_type_temp2 = arg_type_temp[:index + len(package_name + '::' + interface_name)] + '_PaCO' + arg_type_temp[index + len(package_name + '::' + interface_name):]
                            arg_type_temp_temp_return = arg_type_temp[:index + len(package_name + '::' + interface_name)] + '_Return' + arg_type_temp[index + len(package_name + '::' + interface_name):]
                        else :
                            arg_type_temp_temp_return = arg_type_temp
                        if args == '' :
                            args = '*(' + arg_type_temp2 + ' * )' + 'arg_rcp[' + str(arg_number) + ']'
                        else :
                            args = args + ', *(' + arg_type_temp2 + ' * )' +'arg_rcp[' + str(arg_number) + ']'
                        if return_args == '':
                            return_args = '*(' + arg_type_temp_temp_return + ' *)' + 'arg_rcp[' + str(arg_number) + ']'
                        else :
                            return_args = return_args + ', *(' + arg_type_temp_temp_return + ' *)' + 'arg_rcp[' + str(arg_number) + ']'
                        if type_dis_arg == 'Distributed' :
                            free = free + 'cxt->libraries_in[' + str(arg_number-2) + ']->serverFree();\n'
                        else :
                            free = free + 'delete (' + arg_type_temp2 + ' * )arg_rcp[' + str(arg_number) + '];\n'


    code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
    code = base.string_configuration(code, '@@INTERFACE_NAME@@', interface_name)
    code = base.string_configuration(code, '@@PACKAGE_NAME@@', package_name)
    code = base.string_configuration(code, '@@ARGS@@', args)
    code = base.string_configuration(code, '@@OUT_ARGS_DECLARATION@@', out_args_declaration)
    code = base.string_configuration(code, '@@FREE@@', free)
    code = base.string_configuration(code, '@@RETURN_CODE_INIT@@', return_code_init)
    code = base.string_configuration(code, '@@RETURN_ARGS@@', return_args)
#    if oneway == 'no':
#        modes.remove('no_oneway')
    modes.remove('no_oneway')
    return code

