# Written by Andre Ribes 2003
#!/usr/bin/env python

import sys
import os
import string
import base
import complex
import paco

# Arg proxy : 1 ou 0 pour choisir s'il faut generer le contexte pour le proxy chez le serveur ou
# le contexte chez le client
def GenerateClientContext(source_h_file, source_cc_file, configfile, base_name, modes, proxy, debug):
    # Init
    chemin = os.environ['PACOPATH']
    orb = base.search_macro(configfile,'ORB')
    numero_interface = 0
    continu = 'true'
    search_macro_package_name = ''
    
    while continu == 'true':
        numero_interface = numero_interface + 1
        interface_name = base.search_macro(configfile, 'INTERFACE_NAME_' + str(numero_interface))
        package_name = base.search_macro(configfile, 'PACKAGE_NAME_' + str(numero_interface))
        package_name_file = ''
        search_macro_package_name = package_name
        if package_name != '':
            package_name = package_name[2:]
            # search and replace
            package_name_file = package_name
            package_name_file = string.replace(package_name_file, '::', '_')

        if interface_name == 'null':
            continu = 'false'
        else:
	    
	    # Version single file
            if proxy == '0':
                context_h_file = base_name + '_' + package_name_file + '_' + interface_name + '_client.h'
                context_cc_file = base_name + '_' + package_name_file + '_' + interface_name + '_client.cc'
                modes.append("No_Proxy")
            else :
                context_h_file = base_name + '_' + package_name_file + '_' + interface_name + '_server.h'
                context_cc_file = base_name + '_' + package_name_file + '_' + interface_name + '_server.cc'
                modes.append("Proxy")
            method_class = complex.search_method(source_h_file, package_name, interface_name, orb, "CLIENT")

            if package_name != '':
                base.add_namespace(context_h_file, package_name)
            package_name_to_insert = ''
            if package_name != '':
                package_name_to_insert = package_name + '::'

            # Add a gen class for global context class
            base.concanate_files(context_h_file, chemin + '/GenFiles/Base/GenClass.h', modes)
            #
            # Needs NAMESPACE, END, CLASS_NAME, BASE_CLASSES, CONS_ARGS, METHODS, ATTRIBUTES
            #
            namespace = 'class ' + interface_name + '_Return_impl_serv;\n'
            namespace = namespace + 'class PaCO_parallel_layer_' + interface_name + ';'
            end = ''
            class_name = 'global_paco_context'
            base_classes = ' : public PaCO_operation'
            cons_args = package_name_to_insert + interface_name + '_var obj, CORBA::ORB_ptr _orb'
            methods = '  virtual void init(int rank, int total);'
            attributes = ' public:\n'
            #attributes = attributes + '  global_paco_context * return_global_context;\n'
            attributes = attributes + '  CORBA::ORB_ptr orb;\n'
            attributes = attributes + '  ' + interface_name + '_var server_proxy;\n'
            attributes = attributes + '  PaCO::InterfaceManager_var return_proxy;\n'
            attributes = attributes + '  ' + package_name_to_insert + interface_name + '_Return_impl_serv * local_return_layer;\n'
            if proxy == '0':
                attributes = attributes + '  ' + package_name_to_insert + 'PaCO_parallel_layer_' + interface_name + ' * local_layer;'
            else :
                attributes = attributes + '  ' + package_name_to_insert + interface_name + '_proxy_impl * local_layer;'
            #
            configuration_file = open('config_file','wr')
            s = '@@END@@=' + end + '\n'
            configuration_file.write(s)
            s = '@@CLASS_NAME@@=' + class_name + '\n'
            configuration_file.write(s)
            s = '@@BASE_CLASSES@@=' + base_classes + '\n'
            configuration_file.write(s)
            s = '@@CONS_ARGS@@=' + cons_args + '\n'
            configuration_file.write(s)
            s = '@@METHODS@@=' + methods + '\n'
            configuration_file.write(s)
            configuration_file.close()
            base.file_configuration(context_h_file, 'config_file')
            base.StringToString(context_h_file, '@@ATTRIBUTES@@', attributes)
            base.StringToString(context_h_file, '@@NAMESPACE@@', namespace)
            os.remove('config_file')
            # End Part 1.1
            ################################################################################
            # Part 1.2 cc_file
            base.concanate_files(context_cc_file, chemin + '/GenFiles/Base/GenClass.cc', modes)
            # Needs CLASS_NAME, CONS_ARGS, BASE_CLASSES, CODE_CONS, CODE_DES, METHODS, PACKAGE_NAME
            #
            class_name = 'global_paco_context'
            cons_args = package_name_to_insert + interface_name + '_var obj, CORBA::ORB_ptr _orb'
            base_classes = ' : PaCO_operation(0)'
            code_cons = '  server_proxy = obj;\n'
            code_cons = code_cons + '  orb = _orb;'
            code_des = ''
            #
            configuration_file = open('config_file','wr')
            s = '@@CLASS_NAME@@=' + class_name + '\n'
            configuration_file.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            configuration_file.write(s)
            s = '@@CONS_ARGS@@=' + cons_args + '\n'
            configuration_file.write(s)
            s = '@@BASE_CLASSES@@=' + base_classes + '\n'
            configuration_file.write(s)
            s = '@@CODE_DES@@=' + code_des + '\n'
            configuration_file.write(s)
            configuration_file.close()
            base.file_configuration(context_cc_file, 'config_file')
            os.remove('config_file')
            base.StringToString(context_cc_file, '@@CODE_CONS@@', code_cons)
            # Special code for METHODS
            base.StringToFile(context_cc_file,'@@METHODS@@',chemin + '/GenFiles/Base/GenOperation.cc', modes)
            # Configuration
            # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
            retour = 'void'
            nom_methode_complet = 'init(int rank, int total)'
            fichier_config = open('fichier_config','wr')
            s = '@@RETURN@@=' + retour + '\n'
            fichier_config.write(s)
            s = "@@CLASS_NAME@@=" + class_name + "\n"
            fichier_config.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            fichier_config.write(s)
            s = "@@NAME_OPERATION_COMPLETE@@=" + nom_methode_complet + "\n"
            fichier_config.write(s)
            fichier_config.close()
            base.file_configuration(context_cc_file,'fichier_config')
            os.remove('fichier_config')
            # We have to configure macro CODE
            base.StringToFile(context_cc_file,'@@CODE@@',chemin + '/GenFiles/Client/ClientGlobalContextInitMethod.cc', modes)
            # Need INTERFACE_NAME, OPERATION_CONTEXT_INIT, PACKAGE_NAME
            config_file = open('config_file','wr')
            s = "@@INTERFACE_NAME@@=" + interface_name + "\n"
            config_file.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            config_file.write(s)
            config_file.close()
            base.file_configuration(context_cc_file,'config_file')
            os.remove('config_file')
            operation_context_init = ''
            # Add a context for each distributed operation
            for counter in range(len(method_class)):
                if counter != -1:
                    # - virtual
                    chaine = method_class[counter]
                    virtual = string.find(chaine,'virtual ')
                    chaine = chaine[virtual+8:]
                    # pt dans le nom
                    fin_return = string.find(chaine,' ')
                    fin_def = string.find(chaine,')')
                    fin_nom = string.find(chaine,'(')
                    # differents strings
                    retrn =  chaine[:fin_return]
                    operation_name = chaine[fin_return+1:fin_nom]
                    arguments = chaine[fin_nom:fin_def+1]
                    arguments_number = string.count(arguments, ',') + 1

                    # Only for distributed operation
                    type = base.search_macro(configfile,'TYPE_'  + search_macro_package_name + '_' + interface_name + '_' + operation_name)
                    if type == 'distributed':
                        operation_context_init = operation_context_init + '      ' + package_name_to_insert + operation_name + '_context * ' + 'ctx_'+ operation_name +' = ('+ package_name_to_insert + operation_name + '_context * ) this->local_layer->getContext("' + operation_name + '");\n'
                        operation_context_init = operation_context_init + '      ' + 'ctx_' + operation_name + '->init();\n'
                        ################################################################################
                        # Part 1.1 h_file
                        base.concanate_files(context_h_file, chemin + '/GenFiles/Base/GenClass.h', modes)
                        # Needs NAMESPACE, END, CLASS_NAME, BASE_CLASSES, CONS_ARGS, METHODS, ATTRIBUTES, PACKAGE_NAME 
                        #
                        namespace = ''
                        end = ''
                        class_name = operation_name + '_context'
                        base_classes = ' : public PaCO_operation'
                        cons_args = 'int args_number, ' + package_name_to_insert + 'global_paco_context * obj'
                        methods = '  virtual void init();\n'
                        #methods = methods + '  virtual void init_context(PaCO_operation * op);\n'
                        methods = methods + '  virtual void init_complete_context(PaCO_operation * op);'
                        attributes = ' public:\n'
                        attributes = attributes + '  ' + package_name_to_insert + 'global_paco_context * my_global_context;\n'
                        attributes = attributes + '  ' + package_name_to_insert + interface_name + '_Return_impl_serv * local_return_layer;'
                        #
                        configuration_file = open('config_file','wr')
                        s = '@@NAMESPACE@@=' + namespace + '\n'
                        configuration_file.write(s)
                        s = '@@END@@=' + end + '\n'
                        configuration_file.write(s)
                        s = '@@CLASS_NAME@@=' + class_name + '\n'
                        configuration_file.write(s)
                        s = '@@BASE_CLASSES@@=' + base_classes + '\n'
                        configuration_file.write(s)
                        s = '@@CONS_ARGS@@=' + cons_args + '\n'
                        configuration_file.write(s)
                        configuration_file.close()
                        base.file_configuration(context_h_file, 'config_file')
                        base.StringToString(context_h_file, '@@ATTRIBUTES@@', attributes)
                        base.StringToString(context_h_file, '@@METHODS@@', methods)
                        os.remove('config_file')
                        # End Part 1.1
                        ################################################################################
                        # Part 1.2 cc_file
                        base.concanate_files(context_cc_file, chemin + '/GenFiles/Base/GenClass.cc', modes)
                        # Needs CLASS_NAME, CONS_ARGS, BASE_CLASSES, CODE_CONS, CODE_DES, METHODS, PACKAGE_NAME
                        #
                        class_name = operation_name + '_context'
                        cons_args = 'int args_number, '+ package_name_to_insert + 'global_paco_context * obj'
                        base_classes = ' : PaCO_operation(args_number)'
                        code_cons = 'my_global_context = obj;'
                        code_des = ''
                        #
                        configuration_file = open('config_file','wr')
                        s = '@@CLASS_NAME@@=' + class_name + '\n'
                        configuration_file.write(s)
                        s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
                        configuration_file.write(s)
                        s = '@@CONS_ARGS@@=' + cons_args + '\n'
                        configuration_file.write(s)
                        s = '@@BASE_CLASSES@@=' + base_classes + '\n'
                        configuration_file.write(s)
                        s = '@@CODE_DES@@=' + code_des + '\n'
                        configuration_file.write(s)
                        configuration_file.close()
                        base.file_configuration(context_cc_file, 'config_file')
                        base.StringToString(context_cc_file, '@@CODE_CONS@@', code_cons)
                        os.remove('config_file')
                        # Special code for METHODS
                        base.StringToString(context_cc_file, '@@METHODS@@', 'METHODS_1\n\nMETHODS_2\n')
                        #######################################################################################
                        # Method init
                        base.StringToFile(context_cc_file,'METHODS_1',chemin + '/GenFiles/Base/GenOperation.cc', modes)
                        # Configuration
                        # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
                        retour = 'void'
                        nom_methode_complet = 'init()'
                        fichier_config = open('fichier_config','wr')
                        s = '@@RETURN@@=' + retour + '\n'
                        fichier_config.write(s)
                        s = "@@CLASS_NAME@@=" + class_name + "\n"
                        fichier_config.write(s)
                        s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
                        fichier_config.write(s)
                        s = "@@NAME_OPERATION_COMPLETE@@=" + nom_methode_complet + "\n"
                        fichier_config.write(s)
                        fichier_config.close()
                        base.file_configuration(context_cc_file,'fichier_config')
                        os.remove('fichier_config')
                        base.StringToFile(context_cc_file,'@@CODE@@',chemin + '/GenFiles/Client/ClientContextInitMethod.cc', modes)
                        # Need OPERATION_NAME
                        fichier_config = open('fichier_config','wr')
                        s = '@@OPERATION_NAME@@=' + operation_name + '\n'
                        fichier_config.write(s)
                        fichier_config.close()
                        base.file_configuration(context_cc_file,'fichier_config')
                        os.remove('fichier_config')
                        # End method init
                        #######################################################################################
                        # Method init_context
                        #base.StringToFile(context_cc_file,'METHODS_2',chemin + '/GenFiles/Base/GenOperation.cc', modes)
                        # Configuration
                        # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE
                        #retour = 'void'
                        #nom_methode_complet = 'init_context(PaCO_operation * op)'
                        #fichier_config = open('fichier_config','wr')
                        #s = '@@RETURN@@=' + retour + '\n'
                        #fichier_config.write(s)
                        #s = "@@CLASS_NAME@@=" + class_name + "\n"
                        #fichier_config.write(s)
                        #s = "@@NAME_OPERATION_COMPLETE@@=" + nom_methode_complet + "\n"
                        #fichier_config.write(s)
                        #fichier_config.close()
                        #base.file_configuration(context_cc_file,'fichier_config')
                        #os.remove('fichier_config')
                        #base.StringToFile(context_cc_file,'@@CODE@@',chemin + '/GenFiles/Client/ClientContextInitContextMethod.cc', modes)
                        # End method init_context
                        #######################################################################################
                        # Method init_complete_context
                        #base.StringToFile(context_cc_file,'METHODS_3',chemin + '/GenFiles/Base/GenOperation.cc', modes)
			base.StringToFile(context_cc_file,'METHODS_2',chemin + '/GenFiles/Base/GenOperation.cc', modes)
			# Configuration
                        # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
                        retour = 'void'
                        nom_methode_complet = 'init_complete_context(PaCO_operation * op)'
                        fichier_config = open('fichier_config','wr')
                        s = '@@RETURN@@=' + retour + '\n'
                        fichier_config.write(s)
                        s = "@@CLASS_NAME@@=" + class_name + "\n"
                        fichier_config.write(s)
                        s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
                        fichier_config.write(s)
                        s = "@@NAME_OPERATION_COMPLETE@@=" + nom_methode_complet + "\n"
                        fichier_config.write(s)
                        fichier_config.close()
                        base.file_configuration(context_cc_file,'fichier_config')
                        os.remove('fichier_config')
                        base.StringToFile(context_cc_file,'@@CODE@@',chemin + '/GenFiles/Client/ClientContextInitCompleteContextMethod.cc', modes)
                        # End method init_complete_context
                        #######################################################################################
            base.StringToString(context_cc_file, '@@OPERATION_CONTEXT_INIT@@', operation_context_init)
            if package_name != '':
                base.add_namespace_end(context_h_file, package_name)

            if proxy == '0':
                modes.remove("No_Proxy")
            else :
                modes.remove("Proxy")
    
def GenerateServeurContext(source_h_file, source_cc_file, configfile, base_name, modes, debug):
    # Init
    chemin = os.environ['PACOPATH']
    orb = base.search_macro(configfile,'ORB')
    numero_interface = 0
    continu = 'true'
    search_macro_package_name = ''
    
    while continu == 'true':
        numero_interface = numero_interface + 1
        interface_name = base.search_macro(configfile, 'INTERFACE_NAME_' + str(numero_interface))
        package_name = base.search_macro(configfile, 'PACKAGE_NAME_' + str(numero_interface))
        package_name_file = ''
        search_macro_package_name = package_name
        if package_name != '':
            package_name = package_name[2:]
            # search and replace
            package_name_file = package_name
            package_name_file = string.replace(package_name_file, '::', '_')
        if interface_name == 'null':
            continu = 'false'
        else:
	    # Version single file
	    context_h_file = base_name + '_' + package_name_file + '_' + interface_name + '_server.h'
	    context_cc_file = base_name + '_' + package_name_file + '_' + interface_name + '_server.cc'
            method_class = complex.search_method(source_h_file, package_name, interface_name, orb, "CLIENT")

            if package_name != '':
                base.add_namespace(context_h_file, package_name)
            package_name_to_insert = ''
            if package_name != '':
                package_name_to_insert = package_name + '::'

            # Add a global context
            base.concanate_files(context_h_file, chemin + '/GenFiles/Base/GenClass.h', modes)
            # Needs NAMESPACE, END, CLASS_NAME, BASE_CLASSES, CONS_ARGS, METHODS, ATTRIBUTES, PACKAGE_NAME 
            #
            namespace = 'class PaCO_' + interface_name + '_Return;\n'
            end = ''
            class_name = 'global_paco_context_server'
            base_classes = ' : public PaCO_operation'
            cons_args =  package_name_to_insert + 'PaCO_' + interface_name + '_Return * obj, CORBA::ORB_ptr _orb'
            #methods = '  virtual init(int rank, int total);'
            methods = ''
            attributes = ' public:\n'
            #attributes = attributes + '  global_paco_context_server * return_global_context;\n'
            attributes = attributes + '  CORBA::ORB_ptr orb;\n'
            attributes = attributes + '  '+ package_name_to_insert + 'PaCO_' + interface_name + '_Return * my_object;\n'
            attributes = attributes + '  typedef map<int, ' + package_name_to_insert + 'PaCO_' + interface_name + '_Return *> my_object_map;\n'
            attributes = attributes + '  my_object_map my_object_bis;'
                         
            #attributes = attributes + '  PaCO::InterfaceManager_var manager;\n'
            #attributes = attributes + '  ' + interface_name + '_Return_impl_serv * local_node;\n'
            #
            configuration_file = open('config_file','wr')
            s = '@@NAMESPACE@@=' + namespace + '\n'
            configuration_file.write(s)
            s = '@@END@@=' + end + '\n'
            configuration_file.write(s)
            s = '@@CLASS_NAME@@=' + class_name + '\n'
            configuration_file.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            configuration_file.write(s)
            s = '@@BASE_CLASSES@@=' + base_classes + '\n'
            configuration_file.write(s)
            s = '@@CONS_ARGS@@=' + cons_args + '\n'
            configuration_file.write(s)
            s = '@@METHODS@@=' + methods + '\n'
            configuration_file.write(s)
            configuration_file.close()
            base.file_configuration(context_h_file, 'config_file')
            base.StringToString(context_h_file, '@@ATTRIBUTES@@', attributes)
            os.remove('config_file')
            # End Part 1.1
            ################################################################################
            # Part 1.2 cc_file
            base.concanate_files(context_cc_file, chemin + '/GenFiles/Base/GenClass.cc',modes)
            # Needs CLASS_NAME, CONS_ARGS, BASE_CLASSES, CODE_CONS, CODE_DES, METHODS, PACKAGE_NAME
            #
            class_name = 'global_paco_context_server'
            cons_args = package_name_to_insert + 'PaCO_' + interface_name + '_Return * obj, CORBA::ORB_ptr _orb'
            base_classes = ' : PaCO_operation(0)'
            code_cons = '  my_object = obj;\n'
            code_cons = code_cons + '  orb = _orb;'
            #code_cons = code_cons + '  return_global_context = NULL;\n'
            code_des = ''
            methods = ''
            #
            configuration_file = open('config_file','wr')
            s = '@@CLASS_NAME@@=' + class_name + '\n'
            configuration_file.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            configuration_file.write(s)
            s = '@@CONS_ARGS@@=' + cons_args + '\n'
            configuration_file.write(s)
            s = '@@BASE_CLASSES@@=' + base_classes + '\n'
            configuration_file.write(s)
            s = '@@CODE_DES@@=' + code_des + '\n'
            configuration_file.write(s)
            s = '@@METHODS@@=' + methods + '\n'
            configuration_file.write(s)            
            configuration_file.close()
            base.file_configuration(context_cc_file, 'config_file')
            os.remove('config_file')
            base.StringToString(context_cc_file, '@@CODE_CONS@@', code_cons)

            for counter in range(len(method_class)):
                if counter != -1:
                    # - virtual
                    chaine = method_class[counter]
                    virtual = string.find(chaine,'virtual ')
                    chaine = chaine[virtual+8:]
                    # pt dans le nom
                    fin_return = string.find(chaine,' ')
                    fin_def = string.find(chaine,')')
                    fin_nom = string.find(chaine,'(')
                    # differents strings
                    retrn =  chaine[:fin_return]
                    operation_name = chaine[fin_return+1:fin_nom]
                    arguments = chaine[fin_nom:fin_def+1]
                    arguments_number = string.count(arguments, ',') + 1

                    # Only for distributed operation
                    type = base.search_macro(configfile,'TYPE_'  + search_macro_package_name + '_' + interface_name + '_' + operation_name)
                    if type == 'distributed':
                        ################################################################################
                        # Part 1.1 h_file
                        base.concanate_files(context_h_file, chemin + '/GenFiles/Base/GenClass.h', modes)
                        # Needs NAMESPACE, END, CLASS_NAME, BASE_CLASSES, CONS_ARGS, METHODS, ATTRIBUTES, PACKAGE_NAME
                        #
                        namespace = ''
                        end = ''
                        class_name = operation_name + '_server_context'
                        base_classes = ' : public PaCO_operation'
                        #cons_args = 'PaCO::PacoTopology_t srv_topo, int args_number, global_paco_context_server * obj'
			cons_args = 'int args_number, ' + package_name_to_insert + 'global_paco_context_server * obj'
                        methods = '  virtual void init(int client_id);\n'
                        methods = methods + '  virtual void init_complete_context(PaCO_operation * op);'
                        attributes = ' public:\n'
                        attributes = attributes + '  ' + package_name_to_insert + 'global_paco_context_server * my_global_context;'
                        #attributes = attributes + '  PaCO::InterfaceManager_var manager;\n'
                        #attributes = attributes + '  ' + interface_name + '_Return_impl_serv * local_node;\n'
                        #
                        configuration_file = open('config_file','wr')
                        s = '@@NAMESPACE@@=' + namespace + '\n'
                        configuration_file.write(s)
                        s = '@@END@@=' + end + '\n'
                        configuration_file.write(s)
                        s = '@@CLASS_NAME@@=' + class_name + '\n'
                        configuration_file.write(s)
                        s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
                        configuration_file.write(s)
                        s = '@@BASE_CLASSES@@=' + base_classes + '\n'
                        configuration_file.write(s)
                        s = '@@CONS_ARGS@@=' + cons_args + '\n'
                        configuration_file.write(s)
                        configuration_file.close()
                        base.file_configuration(context_h_file, 'config_file')
                        base.StringToString(context_h_file, '@@ATTRIBUTES@@', attributes)
                        base.StringToString(context_h_file, '@@METHODS@@', methods)
                        os.remove('config_file')
                        # End Part 1.1
                        ################################################################################
                        # Part 1.2 cc_file
                        base.concanate_files(context_cc_file, chemin + '/GenFiles/Base/GenClass.cc', modes)
                        # Needs CLASS_NAME, CONS_ARGS, BASE_CLASSES, CODE_CONS, CODE_DES, METHODS, PACKAGE_NAME
                        #
                        class_name = operation_name + '_server_context'
			cons_args = 'int args_number, ' + package_name_to_insert + 'global_paco_context_server * obj'
                        base_classes = ' : PaCO_operation(args_number)'
                        code_cons = 'my_global_context = obj;\n'
                        #code_cons = code_cons + 'server_topo = srv_topo;\n'
                        code_des = ''
                        #
                        configuration_file = open('config_file','wr')
                        s = '@@CLASS_NAME@@=' + class_name + '\n'
                        configuration_file.write(s)
                        s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
                        configuration_file.write(s)
                        s = '@@CONS_ARGS@@=' + cons_args + '\n'
                        configuration_file.write(s)
                        s = '@@BASE_CLASSES@@=' + base_classes + '\n'
                        configuration_file.write(s)
                        s = '@@CODE_CONS@@=' + code_cons + '\n'
                        configuration_file.write(s)
                        s = '@@CODE_DES@@=' + code_des + '\n'
                        configuration_file.write(s)
                        configuration_file.close()
                        base.file_configuration(context_cc_file, 'config_file')
                        os.remove('config_file')
                        # Special code for METHODS
                        base.StringToString(context_cc_file, '@@METHODS@@', 'METHODS_1\nMETHODS_2\n')
                        #######################
                        base.StringToFile(context_cc_file,'METHODS_1',chemin + '/GenFiles/Base/GenOperation.cc', modes)
                        # Configuration
                        # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
                        retour = 'void'
                        nom_methode_complet = 'init(int client_id)'
                        fichier_config = open('fichier_config','wr')
                        s = '@@RETURN@@=' + retour + '\n'
                        fichier_config.write(s)
                        s = "@@CLASS_NAME@@=" + class_name + "\n"
                        fichier_config.write(s)
                        s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
                        fichier_config.write(s)
                        s = "@@NAME_OPERATION_COMPLETE@@=" + nom_methode_complet + "\n"
                        fichier_config.write(s)
                        fichier_config.close()
                        base.file_configuration(context_cc_file,'fichier_config')
                        os.remove('fichier_config')
                        base.StringToFile(context_cc_file,'CODE',chemin + '/GenFiles/Servant/ServantContextInitMethod.cc', modes)
                        # Need OPERATION_NAME
                        fichier_config = open('fichier_config','wr')
                        s = '@@OPERATION_NAME@@=' + operation_name + '\n'
                        fichier_config.write(s)
                        fichier_config.close()
                        base.file_configuration(context_cc_file,'fichier_config')
                        os.remove('fichier_config')
                        #######################################################################################
                        # Method init_complete_context
                        base.StringToFile(context_cc_file,'METHODS_2',chemin + '/GenFiles/Base/GenOperation.cc', modes)
                        # Configuration
                        # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
                        retour = 'void'
                        nom_methode_complet = 'init_complete_context(PaCO_operation * op)'
                        fichier_config = open('fichier_config','wr')
                        s = '@@RETURN@@=' + retour + '\n'
                        fichier_config.write(s)
                        s = "@@CLASS_NAME@@=" + class_name + "\n"
                        fichier_config.write(s)
                        s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
                        fichier_config.write(s)
                        s = "@@NAME_OPERATION_COMPLETE@@=" + nom_methode_complet + "\n"
                        fichier_config.write(s)
                        fichier_config.close()
                        base.file_configuration(context_cc_file,'fichier_config')
                        os.remove('fichier_config')
                        base.StringToFile(context_cc_file,'@@CODE@@',chemin + '/GenFiles/Client/ClientContextInitCompleteContextMethodServeur.cc', modes)
                        # End method init_complete_context
                        #######################################################################################
            if package_name != '':
                base.add_namespace_end(context_h_file, package_name)

