# Written by Andre Ribes 2003
#!/usr/bin/env python

import sys
import os
import string
import base
import complex
import Argument

def GenerateInterfaceManager(h_src_file, configfile, base_name, modes, part, debug):

    #init
    path = os.environ['PACOPATH']
    interface_number = 0
    continu = 'false'
    orb = base.search_macro(configfile,'ORB')
    
    interface_number = 0           # Interface number
    interface_name = ''            # Interface name implied
    package_name = ''              # Interface package name
    package_name_file = ''         # String for the insertion file name
    h_file_name = ''               # Insertion file
    cc_file_name = ''              # Insertion file
    package_name_to_insert = ''    # String for gen files
    method_class = ''              # Methods of the interface
    search_macro_package_name = '' # String for search_macro
    part_save = part
    while continu == 'false':

        interface_number = interface_number + 1
        interface_name = base.search_macro(configfile,'INTERFACE_NAME_' + str(interface_number))
        package_name = base.search_macro(configfile,'PACKAGE_NAME_' + str(interface_number))
        method_class = complex.search_method(h_src_file, package_name[2:], interface_name, orb, "CLIENT")

        if interface_name == 'null':
            continu = 'true'
        else:
            package_name_file = ''  
            h_file_name = ''        
            cc_file_name = ''       
            package_name_to_insert = ''
            search_macro_package_name = ''
            search_macro_package_name = package_name
            if package_name != '':
                package_name = package_name[2:]
                # search and replace
                package_name_file = package_name
                package_name_file = string.replace(package_name_file, '::', '_')

            if debug == '1':
                print '[GenerateInterfaceManager] : interface_name = ' + interface_name 
                print '[GenerateInterfaceManager] : package_name = ' + package_name
                print '[GenerateInterfaceManager] : method_class : '
                print method_class
            part = part_save     
            # File creation : depends of part
            if part == "client" :
                base_file_name = base_name + '_' + package_name_file + '_' + interface_name[:-7] + '_client'
                h_file_name = base_file_name + '.h'
                cc_file_name = base_file_name + '.cc'
                base.create_file(h_file_name)
                base.create_file(cc_file_name)

                # Add include files
                base.add_include(h_file_name, h_src_file)
                base.add_include(h_file_name, "PaCO++.h")
                base.add_include(h_file_name, "PaCO++_src.h")
                base.add_include(h_file_name, "PaCO++_operation.h")
                base.add_include(h_file_name, "string.h")
                base.add_include(cc_file_name, h_file_name)

            elif part == "server" :
                # On commence par configurer le fichier h
                base_file_name = base_name + '_' + package_name_file + '_' + interface_name + '_server'
                h_file_name = base_file_name + '.h'
                cc_file_name = base_file_name + '.cc'
                base.create_file(h_file_name)
                base.create_file(cc_file_name)

                # Add include files
                base.add_include(h_file_name, h_src_file)
                base.add_include(h_file_name, "PaCO++.h")
                base.add_include(h_file_name, "PaCO++_src.h")
                base.add_include(h_file_name, "PaCO++_operation.h")
                base.add_include(h_file_name, "DistributionLibrairie.h")
                base.add_include(h_file_name, "com/paco_com.h")
                base.add_include(h_file_name, "thread/paco_thread.h")
                base.add_include(h_file_name, "string")
                base.add_include(h_file_name, "vector")
                base.add_include(h_file_name, base_name + '_' + package_name_file + '_' + interface_name + '_client.h')
                base.add_include(cc_file_name, h_file_name)

            elif part == "server_return" :
                base_file_name = base_name + '_' + package_name_file + '_' + interface_name[:-7] + '_server'
                h_file_name = base_file_name + '.h'
                cc_file_name = base_file_name + '.cc'
                part = 'client'
                
            # Add namespace
            if package_name != '':
                base.add_namespace(h_file_name, package_name)
                package_name_to_insert = package_name + '::'


            ###########################################################################################################################
            ###########################################################################################################################
            # h file generation

            if part == 'client':
                # Add context class declaration
                base.add_class(h_file_name, 'global_paco_context')
                for counter in range(len(method_class)):
                    method_name = complex.get_method_name(method_class[counter])
                    # On ajoute seulement pour les methodes paralleles
                    type = base.search_macro(configfile,'TYPE_'  + search_macro_package_name + '_' + interface_name + '_' + method_name)
                    if type == 'distributed':
                        base.add_class(h_file_name, method_name + '_context')

            # Add gen class h file
            base.concanate_files(h_file_name, path + '/GenFiles/Base/GenClass.h', modes)
            #
            # Needs NAMESPACE, END, CLASS_NAME, BASE_CLASSES, CONS_ARGS, METHODS, ATTRIBUTES
            #

            namespace = ''
            end = ''

            class_name = interface_name + '_proxy_impl'
            
            base_classes = ' : public InterfaceManager_impl, public '
            if package_name != '' :
                base_classes = base_classes + 'POA_'+ package_name + '::' + interface_name
            else :
                base_classes = base_classes + 'POA_'+ interface_name

            cons_args = 'CORBA::ORB_ptr orb'
            
##             attributes = '  ' + interface_name + '_PaCO_ptr * real_stubs;\n'
##             attributes = attributes + '  int number_stubs;\n'
            attributes = '  int number_stubs;\n'
            attributes = attributes + '  bool connected;\n'
            attributes = attributes + '  CORBA::ORB_ptr _orb;\n'

            if part == 'server':
                attributes =  attributes + package_name_to_insert + 'PaCO_' + interface_name + ' * server;\n'
                
            # Nouvelle version le proxy chez le serveur est un client !
            attributes = attributes + '  ' + package_name_to_insert + 'global_paco_context * global_paco_context_ptr;\n'

            methods = '  PaCO_operation * getContext(string method_name);\n'
            methods = methods + '  void updateContexts();\n'
            methods = methods + '  void finish();\n'
            methods = methods + '  CORBA::Short getClientId();\n'
            methods = methods + '  // Methods of the interface\n'
            
            for counter in range(len(method_class)):
                methods = methods + method_class[counter]
                method_name = complex.get_method_name(method_class[counter])

                # Nouvelle version le proxy chez le serveur est un client !
                type = base.search_macro(configfile,'TYPE_'  + search_macro_package_name + '_' + interface_name + '_' + method_name)
                if type == 'distributed':
                    attributes = attributes + '  ' + package_name_to_insert + method_name + '_context * ' + method_name + '_ptr;\n'

            base.StringToString(h_file_name, '@@NAMESPACE@@', namespace)
            base.StringToString(h_file_name, '@@END@@', end)
            base.StringToString(h_file_name, '@@CLASS_NAME@@', class_name)
            base.StringToString(h_file_name, '@@BASE_CLASSES@@', base_classes)
            base.StringToString(h_file_name, '@@CONS_ARGS@@', cons_args)
            base.StringToString(h_file_name, '@@METHODS@@', methods)
            base.StringToString(h_file_name, '@@ATTRIBUTES@@', attributes)
            if package_name != '':
                base.add_namespace_end(h_file_name, package_name)
            ###########################################################################################################################
            ###########################################################################################################################



            ###########################################################################################################################
            ###########################################################################################################################
            # cc file generation
            base.concanate_files(cc_file_name, path + '/GenFiles/Base/GenClass.cc', modes)
            # Needs CLASS_NAME, CONS_ARGS, BASE_CLASSES, CODE_CONS, CODE_DES, METHODS, PACKAGE_NAME

            # class_name
            # cons_args
            base_classes = ' : InterfaceManager_impl(orb)'

            code_cons = '  number_stubs = 0;\n'
            code_cons = code_cons + '  connected = false;\n'
            code_cons = code_cons + '  _orb = orb;\n'
            code_cons = code_cons + '  global_paco_context_ptr = new global_paco_context(NULL, orb);\n'
##             if part == 'server' :
##                 code_cons = code_cons + '  global_paco_context_ptr->local_layer = this;\n'
            
            code_des = '  delete global_paco_context_ptr;\n'
##            code_des = code_des + '  delete real_stubs;\n'
            
            methods = '@@METHOD_1@@\n@@METHOD_2@@\n@@METHOD_3@@\n@@METHOD_4@@\n'
            
            # For service methods
            for counter in range(len(method_class)):
                code_cons_method = ''
                code_des_method = ''
                methods = methods + '@@METHOD_' + str(counter+5) + '@@\n'
                method_name = complex.get_method_name(method_class[counter])
                type = base.search_macro(configfile,'TYPE_'  + search_macro_package_name + '_' + interface_name + '_' + method_name)
                if type == 'distributed':
                    arguments_number = complex.get_arguments_number(method_class[counter])

                    code_des_method = '  delete ' + method_name + '_ptr;\n'
                    code_cons_method = '  ' + method_name + '_ptr = new ' + package_name_to_insert + method_name + '_context(' + arguments_number + ', global_paco_context_ptr);\n'
                code_cons = code_cons + code_cons_method
                code_des = code_des + code_des_method
            
            # Configuration
            configuration_file = open('config_file','wr')
            s = '@@CLASS_NAME@@=' + class_name + '\n'
            configuration_file.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            configuration_file.write(s)
            s = '@@CONS_ARGS@@=' + cons_args + '\n'
            configuration_file.write(s)
            s = '@@BASE_CLASSES@@=' + base_classes + '\n'
            configuration_file.write(s)
            configuration_file.close()
            base.file_configuration(cc_file_name, 'config_file')
            os.remove('config_file')
            base.StringToString(cc_file_name, '@@CODE_CONS@@', code_cons)
            base.StringToString(cc_file_name, '@@CODE_DES@@', code_des)
            base.StringToString(cc_file_name, '@@METHODS@@', methods)

            #######################################################################################
            # Method finish
            base.StringToFile(cc_file_name,'@@METHOD_1@@',path + '/GenFiles/Base/GenOperation.cc', modes)
            # Configuration
            # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
            retour = 'void'
            nom_methode_complet = 'finish()'
            fichier_config = open('fichier_config','wr')
            s = '@@RETURN@@=void\n'
            fichier_config.write(s)
            s = "@@CLASS_NAME@@=" + class_name + "\n"
            fichier_config.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            fichier_config.write(s)
            s = "@@NAME_OPERATION_COMPLETE@@=" + nom_methode_complet + "\n"
            fichier_config.write(s)
            if part == 'client' :
                s = '@@CODE@@=global_paco_context_ptr->server_proxy->return_ok(global_paco_context_ptr->client_id);\n'
                fichier_config.write(s)
            else :
                #s = "@@CODE@@=// Nothing to do here\n"
                code = ''
                code = base.addFileToString(code, path + '/GenFiles/InterfaceManager/IMFinishMethod.cc', modes)
                # Need : @@PACKAGE_NAME@@, @@INTERFACE_NAME@@, @@INIT_METHOD_CONTEXT@@
                code = base.string_configuration(code, '@@INTERFACE_NAME@@', interface_name)
                code = base.string_configuration(code, '@@PACKAGE_NAME@@', package_name_to_insert)
                init_method_context = ''
                for counter in range(len(method_class)) :
                    result = complex.decompose_method(method_class[counter], 'c++')
                    return_method    = result.pop()
                    method_name      = result.pop()
                    arguments_method = result.pop()
                    type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name)
                    if type == 'distributed':
                        init_method_context = base.addFileToString(init_method_context, path + "/GenFiles/InterfaceManager/InitMethodContext.cc", modes)
                        # Need @@METHOD_NAME@@
                        init_method_context = base.string_configuration(init_method_context, '@@METHOD_NAME@@', method_name)
                code = base.string_configuration(code, '@@INIT_METHOD_CONTEXT@@', init_method_context)
                base.StringToString(cc_file_name, '@@CODE@@', code)
            fichier_config.close()
            base.file_configuration(cc_file_name,'fichier_config')
            os.remove('fichier_config')
            # End method finish
            #######################################################################################

            #######################################################################################
            # Method updateContexts
            base.StringToFile(cc_file_name,'@@METHOD_2@@',path + '/GenFiles/Base/GenOperation.cc', modes)
            # Configuration
            # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
            retour = 'void'
            nom_methode_complet = 'updateContexts()'
            fichier_config = open('fichier_config','wr')
            s = '@@RETURN@@=void\n'
            fichier_config.write(s)
            s = "@@CLASS_NAME@@=" + class_name + "\n"
            fichier_config.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            fichier_config.write(s)
            s = "@@NAME_OPERATION_COMPLETE@@=" + nom_methode_complet + "\n"
            fichier_config.write(s)
            fichier_config.close()
            base.file_configuration(cc_file_name,'fichier_config')
            os.remove('fichier_config')
            # Code
            if part == 'client' :
                code = "// Nothing to do here\n"
            else :
                code = "// We know here the server topology\n"
                code = code + "global_paco_context_ptr->setServerTopo(serveur_topo,\"in\");"
            base.StringToString(cc_file_name, '@@CODE@@', code)
            # End method updateContexts
            #######################################################################################

            #######################################################################################
            # Method PaCO_operation * getContext(string method_name)
            base.StringToFile(cc_file_name,'@@METHOD_3@@',path + '/GenFiles/Base/GenOperation.cc', modes)
            # Configuration
            # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
            retour = 'PaCO_operation *'
            nom_methode_complet = 'getContext(string method_name)'
            fichier_config = open('fichier_config','wr')
            s = '@@RETURN@@=' + retour + '\n'
            fichier_config.write(s)
            s = "@@CLASS_NAME@@=" + class_name + "\n"
            fichier_config.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            fichier_config.write(s)
            s = "@@NAME_OPERATION_COMPLETE@@="+ nom_methode_complet +"\n"
            fichier_config.write(s)
            fichier_config.close()
            base.file_configuration(cc_file_name,'fichier_config')
            os.remove('fichier_config')
            # Code for CODE
            code = ''
            code = base.addFileToString(code, path + '/GenFiles/Base/ParallelGetContext.cc', modes)
            code = base.string_configuration(code, '@@METHOD_NAME@@', 'global_paco_context')
            for counter in range(len(method_class)):
                method_name = complex.get_method_name(method_class[counter])
                type = base.search_macro(configfile,'TYPE_'  + search_macro_package_name + '_' + interface_name + '_' + method_name)
                if type == 'distributed':
                    code = base.addFileToString(code, path + '/GenFiles/Base/ParallelGetContext.cc', modes)
                    code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
	    code = code + "\n return (PaCO_operation*)0;"
            base.StringToString(cc_file_name, '@@CODE@@', code)	    
            # End method PaCO_operation * getContext(string method_name)
            #######################################################################################

            #######################################################################################
            # Method getClientId
            base.StringToFile(cc_file_name,'@@METHOD_4@@',path + '/GenFiles/Base/GenOperation.cc', modes)
            # Configuration
            # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
            retour = 'CORBA::Short'
            nom_methode_complet = 'getClientId()'
            fichier_config = open('fichier_config','wr')
            s = '@@RETURN@@=CORBA::Short\n'
            fichier_config.write(s)
            s = "@@CLASS_NAME@@=" + class_name + "\n"
            fichier_config.write(s)
            s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
            fichier_config.write(s)
            s = "@@NAME_OPERATION_COMPLETE@@=" + nom_methode_complet + "\n"
            fichier_config.write(s)
            fichier_config.close()
            base.file_configuration(cc_file_name,'fichier_config')
            os.remove('fichier_config')
            # Code
            if part == 'client' :
                code = "return global_paco_context_ptr->client_id;\n"
            else :
                code = "// Nothing to do here\n"
            base.StringToString(cc_file_name, '@@CODE@@', code)
            # End method getClientId
            #######################################################################################

            for counter in range(len(method_class)):
                if counter != -1:
                    # - virtual
                    chaine = method_class[counter]
                    virtual = string.find(chaine,'virtual ')
                    chaine = chaine[virtual+8:]
                    # pt dans le nom
                    fin_return = string.find(chaine,' ')
                    fin_def = string.find(chaine,')')
                    fin_nom = string.find(chaine,'(')
                    # differents strings
                    retrn =  chaine[:fin_return]
                    operation_name = chaine[fin_return+1:fin_nom]
                    arguments = chaine[fin_nom:fin_def+1]
                    arguments_number = string.count(arguments, ',') + 1

                    method_number = counter + 5
                    nom_methode_complet = operation_name + arguments                    
                    # Only for distributed operation
                    type = base.search_macro(configfile,'TYPE_'  + search_macro_package_name + '_' + interface_name + '_' + operation_name)
                    if type == 'distributed':
                        base.StringToFile(cc_file_name,'@@METHOD_' + str(method_number) + '@@',path + '/GenFiles/Base/GenOperation.cc', modes)
                        # Configuration
                        # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
                        retour = retrn
                        fichier_config = open('fichier_config','wr')
                        s = '@@RETURN@@=' + retour + '\n'
                        fichier_config.write(s)
                        s = "@@CLASS_NAME@@=" + class_name + "\n"
                        fichier_config.write(s)
                        s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
                        fichier_config.write(s)
                        s = "@@NAME_OPERATION_COMPLETE@@="+ nom_methode_complet +"\n"
                        fichier_config.write(s)
                        fichier_config.close()
                        base.file_configuration(cc_file_name,'fichier_config')
                        os.remove('fichier_config')
                        code = ''
                        if part == 'server' :
                            code = base.addFileToString(code, path + '/GenFiles/InterfaceManager/IMParallelMethod.cc', modes)
                            # Need : PACKAGE_NAME, INTERFACE_NAME, METHOD_NAME, ARGS
                            method_name = operation_name

                            args = ''
                            arguments_temp = arguments
                            while arguments_temp != '':
                                arg = complex.researchArgName(arguments_temp)
                                arg_type = arg.pop()
                                arg_name = arg.pop()
                                arguments_temp = arg.pop()

                                if arg_type != '':
                                    if args == '' :
                                        args = arg_name
                                    else :
                                        args = args + ', ' + arg_name 

                            code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
                            code = base.string_configuration(code, '@@ARGS@@', args)
                            code = base.string_configuration(code, '@@PACKAGE_NAME@@', package_name_to_insert)
                            code = base.string_configuration(code, '@@INTERFACE_NAME@@', interface_name)
                        
                        base.StringToString(cc_file_name, '@@CODE@@', code)
                    else :
                        # By default we call the firts node of the collection
                        base.StringToFile(cc_file_name,'@@METHOD_' + str(method_number) + '@@',path + '/GenFiles/Base/GenOperation.cc', modes)
                        # Configuration
                        # RETURN, CLASS_NAME, NAME_OPERATION_COMPLETE, CODE, PACKAGE_NAME
                        retour = retrn
                        fichier_config = open('fichier_config','wr')
                        s = '@@RETURN@@=' + retour + '\n'
                        fichier_config.write(s)
                        s = "@@CLASS_NAME@@=" + class_name + "\n"
                        fichier_config.write(s)
                        s = '@@PACKAGE_NAME@@=' + package_name_to_insert + '\n'
                        fichier_config.write(s)
                        s = "@@NAME_OPERATION_COMPLETE@@="+ nom_methode_complet +"\n"
                        fichier_config.write(s)
                        fichier_config.close()
                        base.file_configuration(cc_file_name,'fichier_config')
                        os.remove('fichier_config')

                        # Code part
                        if part == "client" :
                            if retrn == 'void' :
                                base.StringToString(cc_file_name, '@@CODE@@', '//Nothing to do')
                            else :
                                base.StringToString(cc_file_name, '@@CODE@@', '  return 0;')
                        else :
                            if retrn == 'void' :
                                modes.append('no_return')
                            else :
                                modes.append('return')
                            code = ''
                            code = base.addFileToString(code, path + '/GenFiles/InterfaceManager/IMSequentialMethod.cc', modes)
                            # Need : METHOD_NAME, ARGS
                            method_name = operation_name
                            args = ''
                            arguments_temp = arguments
                            while arguments_temp != '':
                                arg = complex.researchArgName(arguments_temp)
                                arg_type = arg.pop()
                                arg_name = arg.pop()
                                arguments_temp = arg.pop()
                                if arg_type != '':
                                    if args == '' :
                                        args = arg_name
                                    else :
                                        args = args + ', ' + arg_name 
                            code = base.string_configuration(code, '@@METHOD_NAME@@', method_name)
                            code = base.string_configuration(code, '@@ARGS@@', args)
                            base.StringToString(cc_file_name, '@@CODE@@', code)
                            if retrn == 'void' :
                                modes.remove('no_return')
                            else :
                                modes.remove('return')
                            
