# Written by Andre Ribes 2002
#!/usr/bin/env python

import sys
import os
import string
import base
import complex
import Argument

# GenerateServantStub : create PaCO++ server's layer
# Arg_1 : stub's file .h 
# Arg_2 : configuration file
# Arg_3 : base name of files
# Return : no return
def GenerateServantStub(fichier_source_h, configfile, base_name, modes, debug):

    path = os.environ['PACOPATH']
    orb = base.search_macro(configfile,'ORB')    
    
    interface_number       = 0
    interface_name         = ''
    continu                = 'true'
    package_name           = ''    
    package_name_to_insert = ''
    package_name_file      = ''
    search_macro_package_name = ''
    
    while continu == 'true':
        interface_number = interface_number + 1
        interface_name = base.search_macro(configfile,'INTERFACE_NAME_' + str(interface_number))
        package_name = base.search_macro(configfile,'PACKAGE_NAME_' + str(interface_number))
        search_macro_package_name = package_name
        package_name_to_insert = ''
        package_name_file      = ''
        if package_name != '':
            package_name = package_name[2:]
            # search and replace
            package_name_file = package_name
            package_name_file = string.replace(package_name_file, '::', '_')
            package_name_to_insert = package_name + '::'
        if interface_name == 'null':
            continu = 'false'
        else:
            h_file_name  = base_name + '_' + package_name_file + '_' + interface_name + '_server.h'
	    cc_file_name = base_name + '_' + package_name_file + '_' + interface_name + '_server.cc'
            
            ##################################################################################################################
            ##################################################################################################################
            # .h file generation
            base.concanate_files(h_file_name, path + '/GenFiles/Servant/ServantParallelStub.h', modes)
            #
            # Need @@NAMESPACE@@, @@NAMESPACE_END@@, @@INTERFACE_NAME@@, @@CLASS_NAME@@, @@INSERT_METHODS@@, @@STRUCTS@@
            #
            namespace          = ''
            namespace_end      = ''
	    class_name         = ''
            insert_methods     = ''
            structs            = ''

            if package_name != '':
                package_name_temp = package_name
                index = 0
                while index != -1:
                    index = string.find(package_name_temp, "::")
                    if index == -1:
                        namespace = namespace + "namespace " + package_name_temp + " {\n"
                        namespace_end = namespace_end + "};\n"
                    else:
                        namespace = namespace + "namespace " + package_name_temp[:index] + " {\n"
                        namespace_end = namespace_end + "};\n"
                        package_name_temp =  package_name_temp[index+2:]

            if package_name != '':
                class_name = 'POA_'+ package_name + '::' + interface_name + '_PaCO\n'
            else:
                class_name = 'POA_' + interface_name + '_PaCO\n'

            structs = package_name_to_insert + 'global_paco_context_server * global_paco_context_ptr;\n'
            method_class = complex.search_method(fichier_source_h, package_name, interface_name + '_PaCO', orb, "SERVANT")
            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method    = result.pop()
                method_name      = result.pop()
                arguments_method = result.pop()
                index = string.find(method_name, '_PaCO')
                method_name_search = ''
                if index !=  -1:
                    method_name_search = method_name[:index]
                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name_search)
                if type == 'distributed':
                    insert_methods = insert_methods + method_class[counter]
                    insert_methods = insert_methods + '  void '+ method_name_search + '_end();\n'    # To remove
                    structs = structs + '  ' + package_name_to_insert + method_name_search + '_server_context * ' + method_name_search + '_ptr;\n'

            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method    = result.pop()
                method_name      = result.pop()
                arguments_method = result.pop()
                index = string.find(method_name, '_PaCO')
                method_name_search = ''
                if index !=  -1:
                    method_name_search = method_name[:index]
                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name_search)


                # FIX: A QUOI CE LA SERT: juste une def dans un .h qui n'est pas utilis !!!!!
                if type == 'distributed':
                    namespace_end = namespace_end + 'void ' + package_name + '_' + interface_name + '_' + method_name + '_thread(void * arg); // detached thread\n'

            base.StringToString(h_file_name, '@@NAMESPACE@@', namespace)
            base.StringToString(h_file_name, '@@NAMESPACE_END@@', namespace_end)
            base.StringToString(h_file_name, '@@INTERFACE_NAME@@', interface_name)
            base.StringToString(h_file_name, '@@CLASS_NAME@@', class_name)
            base.StringToString(h_file_name, '@@INSERT_METHODS@@', insert_methods)
            base.StringToString(h_file_name, '@@STRUCTS@@', structs)
        
            ##################################################################################################################
            ##################################################################################################################

            ##################################################################################################################
            ##################################################################################################################
            # .cc file generation
            
            base.concanate_files(cc_file_name,path + '/GenFiles/Base/GenClass.cc', modes)
            #
            # Need @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@CONS_ARGS@@ @@BASE_CLASSES@@ @@CODE_CONS@@ @@CODE_DES@@ @@METHODS@@
            #
            class_name   = ''
            cons_args    = ''
            base_classes = ''
            code_cons    = ''
            code_des     = ''
            methods      = ''

            class_name   = interface_name + '_serv'
            cons_args    = 'CORBA::ORB_ptr current_orb, char * ior'
            base_classes = ' : InterfaceParallel_impl(current_orb,ior)'

            code_cons = base.addFileToString(code_cons, path + '/GenFiles/Servant/ServantParallelStubConstructorGlobalContextServeur.cc', modes)
            # Need @@PACKAGE_NAME@@
            code_cons = base.string_configuration(code_cons, "@@PACKAGE_NAME@@", package_name_to_insert)
            code_des  = base.addFileToString(code_des, path + '/GenFiles/Servant/ServantParallelStubDestructorGlobalContext.cc', modes)

            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method     = result.pop()
                method_name       = result.pop()
                arguments_method  = result.pop()
                args_number       = complex.get_arguments_number(method_class[counter])
                
                index = string.find(method_name,'_PaCO')
                method_name_search = ''
                if index != -1:
                    method_name_search = method_name[:index]
                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name_search)
                if type == 'distributed' :
                    code_cons = base.addFileToString(code_cons, path + '/GenFiles/Servant/ServantParallelStubConstructor.cc', modes)
                    # Need @@METHOD_NAME@@ @@PACKAGE_NAME@@ @@ARGS_NUMBER@@
                    code_cons = base.string_configuration(code_cons, "@@PACKAGE_NAME@@", package_name_to_insert)
                    code_cons = base.string_configuration(code_cons, "@@METHOD_NAME@@", method_name_search)
                    code_cons = base.string_configuration(code_cons, "@@ARGS_NUMBER@@", args_number)
                    code_des  = base.addFileToString(code_des, path + '/GenFiles/Servant/ServantParallelStubDestructor.cc', modes)
                    # Need @@METHOD_NAME@@
                    code_des = base.string_configuration(code_des, "@@METHOD_NAME@@", method_name_search)
            
            ################################
            # Method getContext
            methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
            # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
            return_code = ''
            name_operation_complete = ''
            code = ''

            return_code = 'PaCO_operation *'
            name_operation_complete = 'getContext(string method_name)'
            code = base.addFileToString(code, path + "/GenFiles/Base/ParallelGetContext.cc", modes)
            # Need @@METHOD_NAME@@
            code = base.string_configuration(code, "@@METHOD_NAME@@", "global_paco_context")
            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method     = result.pop()
                method_name       = result.pop()
                arguments_method  = result.pop()
                index = string.find(method_name,'_PaCO')
                method_name_search = ''
                if index != -1:
                    method_name_search = method_name[:index]
                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name_search)
                if type == 'distributed' :
                    code = base.addFileToString(code, path + "/GenFiles/Base/ParallelGetContext.cc", modes)
                    # Need @@METHOD_NAME@@
                    code = base.string_configuration(code, "@@METHOD_NAME@@", method_name_search)

	    code = code + "\n return (PaCO_operation*)0;"

            methods = base.string_configuration(methods, "@@RETURN@@", return_code)
            methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
            methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
            methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
            methods = base.string_configuration(methods, "@@CODE@@", code)
            ################################

            ################################
            # Method init_InterfaceParallel
            methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
            # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
            return_code = ''
            name_operation_complete = ''
            code = ''

            return_code = 'void'
            name_operation_complete = 'init_InterfaceParallel(CORBA::Short myRank, CORBA::Short totalNode, const PaCO::PacoTopology_t& topo)'
            code = base.addFileToString(code, path + '/GenFiles/Servant/init_InterfaceParallelOperation.cc', modes)
            
            methods = base.string_configuration(methods, "@@RETURN@@", return_code)
            methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
            methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
            methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
            methods = base.string_configuration(methods, "@@CODE@@", code)
            ################################
            
            ################################
            # Method connect_return_object
            methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
            # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
            return_code = ''
            name_operation_complete = ''
            code = ''

            return_code = 'void'
            name_operation_complete = 'connect_return_object(const CORBA::Short client_id)'

            code = base.addFileToString(code, path + '/GenFiles/Servant/ConnectCodeNormal.cc', modes)
            # Need @@INTERFACE_NAME@@, @@INIT_CONTEXT_METHOD_LOCAL@@
            init_context_method_local = ''
            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method     = result.pop()
                method_name       = result.pop()
                arguments_method  = result.pop()
                index = string.find(method_name,'_PaCO')
                method_name_search = ''
                if index != -1:
                    method_name_search = method_name[:index]
                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name_search)
                if type == 'distributed' :
                    init_context_method_local = base.addFileToString(init_context_method_local, path + '/GenFiles/Servant/InitContextMethodLocal.cc', modes)
                    # Need @@METHOD_NAME@@
                    init_context_method_local = base.string_configuration(init_context_method_local, "@@METHOD_NAME@@", method_name_search)
            
            code = base.string_configuration(code, "@@INTERFACE_NAME@@", interface_name)
            code = base.string_configuration(code, "@@INIT_CONTEXT_METHOD_LOCAL@@", init_context_method_local)

            methods = base.string_configuration(methods, "@@RETURN@@", return_code)
            methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
            methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
            methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
            methods = base.string_configuration(methods, "@@CODE@@", code)
            ################################

            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method     = result.pop()
                method_name       = result.pop()
                arguments_method  = result.pop()
                index = string.find(method_name,'_PaCO')
                method_name_search = ''
                if index != -1:
                    method_name_search = method_name[:index]
                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name_search)
                if type == 'distributed' :
                    
                    ################################
                    # _end method : TO REMOVE !!!!!
                    methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
                    # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                    return_code = ''
                    name_operation_complete = ''
                    code = ''
                    
                    return_code = 'void'
                    name_operation_complete = method_name_search + '_end()'
                    
                    methods = base.string_configuration(methods, "@@RETURN@@", return_code)
                    methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
                    methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
                    methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
                    methods = base.string_configuration(methods, "@@CODE@@", code)
                    ################################

                    ################################
                    # Thread method
                    methods = base.addFileToString(methods, path + '/GenFiles/Base/GenMethod.cc', modes)
                    # Need @@RETURN@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                    return_code = 'void'
                    name_operation_complete = package_name + '_' + interface_name + '_' + method_name[:-5] + '_thread(void * arg) // detached thread' # - _PaCO
                    code = ''
                    code = Argument.get_server_thread_dis_code(package_name, arguments_method, interface_name, method_name, fichier_source_h, configfile, orb, modes, debug)
                    
                    methods = base.string_configuration(methods, "@@RETURN@@", return_code)
                    methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
                    methods = base.string_configuration(methods, "@@CODE@@", code)

                    # Parallel method 
                    methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
                    # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                    name_operation_complete = ''
                    code = ''

                    name_operation_complete = method_name + arguments_method[:-2]
                    code = Argument.get_server_dis_code(package_name, arguments_method, interface_name, method_name_search, fichier_source_h, configfile, orb, modes, debug)

                    methods = base.string_configuration(methods, "@@RETURN@@", return_method)
                    methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
                    methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
                    methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
                    methods = base.string_configuration(methods, "@@CODE@@", code)

                    ################################
                    
            base.StringToString(cc_file_name, '@@PACKAGE_NAME@@', package_name_to_insert)
            base.StringToString(cc_file_name, '@@CLASS_NAME@@', class_name)
            base.StringToString(cc_file_name, '@@CONS_ARGS@@', cons_args)
            base.StringToString(cc_file_name, '@@BASE_CLASSES@@', base_classes)
            base.StringToString(cc_file_name, '@@CODE_CONS@@', code_cons)
            base.StringToString(cc_file_name, '@@CODE_DES@@', code_des)
            base.StringToString(cc_file_name, '@@METHODS@@', methods)

            

# GenerateServant_Return create PaCO++ server's return implementation
# Arg_1 : stub's file .h 
# Arg_2 : configuration file
# Arg_3 : base name of files
# Return : no return

def GenerateServant_Return(fichier_source_h, configfile, base_name, modes, debug, proxy):

    path = os.environ['PACOPATH']
    orb = base.search_macro(configfile,'ORB')

    interface_number       = 0
    interface_name         = ''
    continu                = 'true'
    package_name           = ''    
    package_name_to_insert = ''
    package_name_file      = ''
    search_macro_package_name = ''
    while continu == 'true':
        interface_number = interface_number + 1
        interface_name = base.search_macro(configfile,'INTERFACE_NAME_' + str(interface_number))
        package_name = base.search_macro(configfile,'PACKAGE_NAME_' + str(interface_number))
        search_macro_package_name = package_name
        package_name_to_insert = ''
        package_name_file      = ''
        if package_name != '':
            package_name = package_name[2:]
            # search and replace
            package_name_file = package_name
            package_name_file = string.replace(package_name_file, '::', '_')
            package_name_to_insert = package_name + '::'
        if interface_name == 'null':
            continu = 'false'
        else:
            if proxy == '0':
                base_file_name = base_name + '_' + package_name_file + '_' + interface_name[:-7] + '_client'
            else :
                base_file_name = base_name + '_' + package_name_file + '_' + interface_name[:-7] + '_server'
            h_file_name  = base_file_name + '.h'
            cc_file_name = base_file_name + '.cc'

            ##################################################################################################################
            ##################################################################################################################
            # .h file generation : Servant class
            base.concanate_files(h_file_name, path + '/GenFiles/Servant/ServantParallelStub.h', modes)
            #
            # Need @@NAMESPACE@@, @@NAMESPACE_END@@, @@INTERFACE_NAME@@, @@CLASS_NAME@@, @@INSERT_METHODS@@, @@STRUCTS@@
            #
            namespace          = ''
            namespace_end      = ''
	    class_name         = ''
            insert_methods     = ''
            structs            = ''

            if package_name != '':
                package_name_temp = package_name
                index = 0
                while index != -1:
                    index = string.find(package_name_temp, "::")
                    if index == -1:
                        namespace = namespace + "namespace " + package_name_temp + " {\n"
                        namespace_end = namespace_end + "};\n"
                    else:
                        namespace = namespace + "namespace " + package_name_temp[:index] + " {\n"
                        namespace_end = namespace_end + "};\n"
                        package_name_temp =  package_name_temp[index+2:]
            if package_name != '':
                class_name = 'POA_'+ package_name + '::' + interface_name + '_PaCO\n'
            else:
                class_name = 'POA_' + interface_name + '_PaCO\n'

            structs = 'protected :\n'
            structs = structs + package_name_to_insert + 'global_paco_context * global_paco_context_ptr;\n'
            method_class = complex.search_method(fichier_source_h, package_name, interface_name + '_PaCO', orb, "SERVANT")
            if debug == '1':
                print "Method class found for servant return :"
                print method_class
            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method    = result.pop()
                method_name      = result.pop()
                arguments_method = result.pop()
                index = string.find(method_name, '_PaCO')
                paco_method = 'false'
                method_name_search = ''
                if index !=  -1:
                    method_name_search = method_name[:index]
                    paco_method = 'true'
                else :
                    method_name_search = method_name
                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name_search)
                if type == 'distributed':
                    if paco_method == 'false' :
#                        if string.find(arguments_method, ',') == -1 :
                        if string.find(arguments_method, '()') != -1:
                            arguments_method = arguments_method[:-3] + 'const CORBA::Short client_id' + arguments_method[-3:]
                        else :
                            arguments_method = arguments_method[:-3] + ', const CORBA::Short client_id' + arguments_method[-3:]
                        insert_methods = insert_methods + '  virtual ' + return_method + ' ' + method_name + '_Recv' + arguments_method[:-2] + ' = 0;\n'
                        insert_methods = insert_methods + '  void '+ method_name + '_end();\n'    # To remove
                        structs = structs + '  ' + package_name_to_insert + method_name_search + '_context * ' + method_name_search + '_ptr;\n'                        
                    else :
                        insert_methods = insert_methods + '  ' + method_class[counter]

            base.StringToString(h_file_name, '@@NAMESPACE@@', namespace)
            base.StringToString(h_file_name, '@@NAMESPACE_END@@', namespace_end)
            base.StringToString(h_file_name, '@@INTERFACE_NAME@@', interface_name)
            base.StringToString(h_file_name, '@@CLASS_NAME@@', class_name)
            base.StringToString(h_file_name, '@@INSERT_METHODS@@', insert_methods)
            base.StringToString(h_file_name, '@@STRUCTS@@', structs)
        
            ##################################################################################################################
            ##################################################################################################################

            ##################################################################################################################
            ##################################################################################################################
            # .h file generation : Servant impl class
            base.concanate_files(h_file_name, path + '/GenFiles/Servant/ServantParallelReturnStub.h', modes)
            #
            # Need @@NAMESPACE@@, @@NAMESPACE_END@@, @@INTERFACE_NAME@@, @@CLASS_NAME@@, @@INSERT_METHODS@@, @@STRUCTS@@
            #
            namespace          = ''
            namespace_end      = ''
	    class_name         = ''
            insert_methods     = ''
            structs            = ''

            if package_name != '':
                package_name_temp = package_name
                index = 0
                while index != -1:
                    index = string.find(package_name_temp, "::")
                    if index == -1:
                        namespace = namespace + "namespace " + package_name_temp + " {\n"
                        namespace_end = namespace_end + "};\n"
                    else:
                        namespace = namespace + "namespace " + package_name_temp[:index] + " {\n"
                        namespace_end = namespace_end + "};\n"
                        package_name_temp =  package_name_temp[index+2:]
            if package_name != '':
                class_name = package_name + '::' + interface_name + '_serv\n'
            else:
                class_name = interface_name + '_serv\n'

            method_class = complex.search_method(fichier_source_h, package_name, interface_name + '_PaCO', orb, "SERVANT")
            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method    = result.pop()
                method_name      = result.pop()
                arguments_method = result.pop()

                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name)
                if type == 'distributed':
                    insert_methods = insert_methods + method_class[counter]

                    #if string.find(arguments_method, ',') == -1 :
                    if string.find(arguments_method, '()') != -1:                        
                        arguments_method = arguments_method[:-3] + 'const CORBA::Short client_id' + arguments_method[-3:]
                    else :
                        arguments_method = arguments_method[:-3] + ', const CORBA::Short client_id' + arguments_method[-3:]

                    insert_methods = insert_methods + '  virtual ' + return_method + ' ' + method_name + '_Recv' + arguments_method[:-2] + ';\n'
                    arguments_init = ''
                    while arguments_method != '':
                        arg = complex.researchArgName(arguments_method)
                        arg_type = arg.pop()
                        arg_name = arg.pop()
                        arguments_method = arg.pop()
                        macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
                        macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'
                        type_dis_arg = base.search_macro(configfile,macro)
                        type_arg = base.search_macro(configfile,macro_type)
                        if type_arg == 'in' :
                            # Version simpliste : on recopie tout !!!
                            # Refaire en optimisant les sequences
                            structs = structs + arg_type + ' **' + arg_name + '_rcp;\n'
                            if arguments_init == '':
                                arguments_init = arg_type + ' **' + arg_name
                            else :
                                arguments_init = arguments_init + ', ' + arg_type + ' **' + arg_name
                    insert_methods = insert_methods + '  void ' + method_name + '_init(' + arguments_init + ');\n'
                else :
                    # Dirty !
                    insert_method = 'true'
                    index = string.find(method_name, '_end')
                    if index != -1:
                        temp = method_name[:index]
                        if base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + temp) == 'distributed':
                            insert_method = 'false'
                    index = string.find(method_name, '_PaCO')
                    if index != -1:
                        temp = method_name[:index]
                        if base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + temp) == 'distributed':
                            insert_method = 'false'
                    if insert_method == 'true' :
                        insert_methods = insert_methods + return_method + ' ' + method_name + arguments_method[:-2] + '{}\n'
                    
            base.StringToString(h_file_name, '@@NAMESPACE@@', namespace)
            base.StringToString(h_file_name, '@@NAMESPACE_END@@', namespace_end)
            base.StringToString(h_file_name, '@@INTERFACE_NAME@@', interface_name)
            base.StringToString(h_file_name, '@@CLASS_NAME@@', class_name)
            base.StringToString(h_file_name, '@@INSERT_METHODS@@', insert_methods)
            base.StringToString(h_file_name, '@@STRUCTS@@', structs)
            ##################################################################################################################
            ##################################################################################################################
            
            ##################################################################################################################
            ##################################################################################################################
            # .cc file generation : Servant class
            
            base.concanate_files(cc_file_name,path + '/GenFiles/Base/GenClass.cc', modes)
            #
            # Need @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@CONS_ARGS@@ @@BASE_CLASSES@@ @@CODE_CONS@@ @@CODE_DES@@ @@METHODS@@
            #
            class_name   = ''
            cons_args    = ''
            base_classes = ''
            code_cons    = ''
            code_des     = ''
            methods      = ''

            class_name   = interface_name + '_serv'
            cons_args    = 'CORBA::ORB_ptr current_orb, char * ior'
            base_classes = ' : InterfaceParallel_impl(current_orb,ior)'

            code_cons = base.addFileToString(code_cons, path + '/GenFiles/Servant/ServantParallelStubConstructorGlobalContext.cc', modes)
            # Need @@PACKAGE_NAME@@
            code_cons = base.string_configuration(code_cons, "@@PACKAGE_NAME@@", package_name_to_insert)
            code_des  = base.addFileToString(code_des, path + '/GenFiles/Servant/ServantParallelStubDestructorGlobalContext.cc', modes)

            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method     = result.pop()
                method_name       = result.pop()
                arguments_method  = result.pop()
                args_number       = complex.get_arguments_number(method_class[counter])
                
                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name)
                if type == 'distributed' :
                    code_cons = base.addFileToString(code_cons, path + '/GenFiles/Servant/ServantParallelStubConstructorReturn.cc', modes)
                    # Need @@METHOD_NAME@@ @@PACKAGE_NAME@@ @@ARGS_NUMBER@@
                    code_cons = base.string_configuration(code_cons, "@@PACKAGE_NAME@@", package_name_to_insert)
                    code_cons = base.string_configuration(code_cons, "@@METHOD_NAME@@", method_name)
                    code_cons = base.string_configuration(code_cons, "@@ARGS_NUMBER@@", args_number)
                    code_des  = base.addFileToString(code_des, path + '/GenFiles/Servant/ServantParallelStubDestructor.cc', modes)
                    # Need @@METHOD_NAME@@
                    code_des = base.string_configuration(code_des, "@@METHOD_NAME@@", method_name)
            
            ################################
            # Method getContext
            methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
            # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
            return_code = ''
            name_operation_complete = ''
            code = ''

            return_code = 'PaCO_operation *'
            name_operation_complete = 'getContext(string method_name)'
            code = base.addFileToString(code, path + "/GenFiles/Base/ParallelGetContext.cc", modes)
            # Need @@METHOD_NAME@@
            code = base.string_configuration(code, "@@METHOD_NAME@@", "global_paco_context")
            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method     = result.pop()
                method_name       = result.pop()
                arguments_method  = result.pop()
                index = string.find(method_name,'_PaCO')

                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name)
                if type == 'distributed' :
                    code = base.addFileToString(code, path + "/GenFiles/Base/ParallelGetContext.cc", modes)
                    # Need @@METHOD_NAME@@
                    code = base.string_configuration(code, "@@METHOD_NAME@@", method_name)

	    code = code + "\n   return (PaCO_operation*)0;"

            methods = base.string_configuration(methods, "@@RETURN@@", return_code)
            methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
            methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
            methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
            methods = base.string_configuration(methods, "@@CODE@@", code)
            ################################

            ################################
            # Method init_InterfaceParallel
            methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
            # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
            return_code = ''
            name_operation_complete = ''
            code = ''

            return_code = 'void'
            name_operation_complete = 'init_InterfaceParallel(CORBA::Short myRank, CORBA::Short totalNode, const PaCO::PacoTopology_t& topo)'
            code = 'InterfaceParallel_impl::init_InterfaceParallel(myRank,totalNode);'
            
            methods = base.string_configuration(methods, "@@RETURN@@", return_code)
            methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
            methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
            methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
            methods = base.string_configuration(methods, "@@CODE@@", code)
            ################################
            
            ################################
            # Method connect_return_object
            methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
            # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
            return_code = ''
            name_operation_complete = ''
            code = ''

            return_code = 'void'
            name_operation_complete = 'connect_return_object(const CORBA::Short client_id)'
            code = '  // Nothing to do'

            methods = base.string_configuration(methods, "@@RETURN@@", return_code)
            methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
            methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
            methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
            methods = base.string_configuration(methods, "@@CODE@@", code)
            ################################
            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method     = result.pop()
                method_name       = result.pop()
                arguments_method  = result.pop()
                index = string.find(method_name,'_PaCO')
                method_name_search = ''
                if index != -1:
                    method_name_search = method_name[:index]
                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name_search)
                if type == 'distributed' :
                    
                    ################################
                    # _end method : TO REMOVE !!!!!
                    methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
                    # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                    return_code = ''
                    name_operation_complete = ''
                    code = ''
                    
                    return_code = 'void'
                    name_operation_complete = method_name_search + '_end()'
                    
                    methods = base.string_configuration(methods, "@@RETURN@@", return_code)
                    methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
                    methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
                    methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
                    methods = base.string_configuration(methods, "@@CODE@@", code)
                    ################################

                    ################################
                    # Parallel method 
                    methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
                    # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                    name_operation_complete = ''
                    code = ''
                    
                    name_operation_complete = method_name + arguments_method[:-2]
                    modes.append('client')
                    code = Argument.get_server_dis_code(package_name, arguments_method, interface_name, method_name_search, fichier_source_h, configfile, orb, modes, debug)
                    modes.remove('client')
                    methods = base.string_configuration(methods, "@@RETURN@@", return_method)
                    methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
                    methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
                    methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
                    methods = base.string_configuration(methods, "@@CODE@@", code)
                    ################################
                    
            base.StringToString(cc_file_name, '@@PACKAGE_NAME@@', package_name_to_insert)
            base.StringToString(cc_file_name, '@@CLASS_NAME@@', class_name)
            base.StringToString(cc_file_name, '@@CONS_ARGS@@', cons_args)
            base.StringToString(cc_file_name, '@@BASE_CLASSES@@', base_classes)
            base.StringToString(cc_file_name, '@@CODE_CONS@@', code_cons)
            base.StringToString(cc_file_name, '@@CODE_DES@@', code_des)
            base.StringToString(cc_file_name, '@@METHODS@@', methods)
            ##################################################################################################################
            ##################################################################################################################
            
            ##################################################################################################################
            ##################################################################################################################
            # .cc file generation : Servant impl class
            
            base.concanate_files(cc_file_name, path + '/GenFiles/Base/GenClass.cc', modes)
            #
            # Need @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@CONS_ARGS@@ @@BASE_CLASSES@@ @@CODE_CONS@@ @@CODE_DES@@ @@METHODS@@
            #
            class_name   = ''
            cons_args    = ''
            code_cons    = ''
            code_des     = ''
            methods      = ''

            class_name   = interface_name + '_impl_serv'
            cons_args    = 'CORBA::ORB_ptr current_orb, char * ior'
            base_classes = ' : ' + interface_name + '_serv(current_orb,ior)'

            for counter in range(len(method_class)) :
                result = complex.decompose_method(method_class[counter], 'c++')
                return_method     = result.pop()
                method_name       = result.pop()
                arguments_method  = result.pop()
                index = string.find(method_name,'_PaCO')

                type = base.search_macro(configfile,'TYPE_' + search_macro_package_name + '_' + interface_name + '_' + method_name)
                if type == 'distributed' :
                    ################################
                    # _init method
                    methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
                    # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                    return_code = ''
                    name_operation_complete = ''
                    arguments_init = ''
                    code = ''
                    
                    return_code = 'void'

                    
                    code = base.addFileToString(code, path + "/GenFiles/Servant/ServantParallelReturnImplInitOperation.cc", modes)
                    # Need @@CODE_INIT@@, @@METHOD_NAME@@
                    code_init = ''
                    arguments_temp = arguments_method
                    while arguments_temp != '':
                        arg = complex.researchArgName(arguments_temp)
                        arg_type = arg.pop()
                        arg_name = arg.pop()
                        arguments_temp = arg.pop()
                        
                        macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
                        macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'
                        type_dis_arg = base.search_macro(configfile,macro)
                        type_arg = base.search_macro(configfile,macro_type)
                        if type_arg == 'in' :
                            code_init = code_init + arg_name + '_rcp = ' + arg_name + ';\n'
                            if arguments_init == '':
                                arguments_init = arg_type + ' ** ' + arg_name
                            else :
                                arguments_init = arguments_init + ', ' + arg_type + ' ** ' + arg_name
                            
                    name_operation_complete = method_name + '_init(' + arguments_init + ')'
                    code = base.string_configuration(code, "@@METHOD_NAME@@", method_name)
                    code = base.string_configuration(code, "@@CODE_INIT@@", code_init)

                    methods = base.string_configuration(methods, "@@RETURN@@", return_code)
                    methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
                    methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
                    methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
                    methods = base.string_configuration(methods, "@@CODE@@", code)
                    ################################

                    ################################
                    # _Recv method
                    methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
                    # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                    name_operation_complete = ''
                    code = ''
                    
#                    if string.find(arguments_method, ',') == -1 :
                    if string.find(arguments_method, '()') != -1:    
                        arguments_method_temp = arguments_method[:-3] + 'const CORBA::Short client_id' + arguments_method[-3:]
                    else :
                        arguments_method_temp = arguments_method[:-3] + ', const CORBA::Short client_id' + arguments_method[-3:]
                        
                    name_operation_complete = method_name + '_Recv' + arguments_method_temp[:-2]
                    
                    code = base.addFileToString(code, path + "/GenFiles/Servant/ServantParallelReturnImplRecvOperation.cc", modes)
                    # Need @@METHOD_NAME@@, @@CODE_RECV@@
                    code_recv = ''
                    arguments_temp = arguments_method
                    while arguments_temp != '':
                        arg = complex.researchArgName(arguments_temp)
                        arg_type = arg.pop()
                        arg_name = arg.pop()
                        arguments_temp = arg.pop()
                        
                        macro = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name
                        macro_type = 'ARG_' + search_macro_package_name + '_' + interface_name + '_' + method_name + '_' + arg_name + '_Type'
                        type_dis_arg = base.search_macro(configfile,macro)
                        type_arg = base.search_macro(configfile,macro_type)
                        if type_arg == 'in' :
                            code_recv = code_recv + '*' + arg_name + '_rcp = new ' + arg_type + '(' + arg_name + ');\n'
                            
                    code = base.string_configuration(code, "@@METHOD_NAME@@", method_name)
                    code = base.string_configuration(code, "@@CODE_RECV@@", code_recv)

                    methods = base.string_configuration(methods, "@@RETURN@@", return_method)
                    methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
                    methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
                    methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
                    methods = base.string_configuration(methods, "@@CODE@@", code)
                    ################################

                    ################################
                    # normal method
                    methods = base.addFileToString(methods, path + '/GenFiles/Base/GenOperation.cc', modes)
                    # Need @@RETURN@@ @@PACKAGE_NAME@@ @@CLASS_NAME@@ @@NAME_OPERATION_COMPLETE@@ @@CODE@@
                    name_operation_complete = ''
                    code = ''
                    
                    name_operation_complete = method_name + arguments_method[:-2]
                    
                    code = base.addFileToString(code, path + "/GenFiles/Servant/ServantParallelImplWaitReturn.cc", modes)
                    # Need @@METHOD_NAME@@
                    code = base.string_configuration(code, "@@METHOD_NAME@@", method_name)
                    
                    methods = base.string_configuration(methods, "@@RETURN@@", return_method)
                    methods = base.string_configuration(methods, "@@PACKAGE_NAME@@", package_name_to_insert)
                    methods = base.string_configuration(methods, "@@CLASS_NAME@@", class_name)
                    methods = base.string_configuration(methods, "@@NAME_OPERATION_COMPLETE@@", name_operation_complete)
                    methods = base.string_configuration(methods, "@@CODE@@", code)
                    ################################
                    
            base.StringToString(cc_file_name, '@@PACKAGE_NAME@@', package_name_to_insert)
            base.StringToString(cc_file_name, '@@CLASS_NAME@@', class_name)
            base.StringToString(cc_file_name, '@@CONS_ARGS@@', cons_args)
            base.StringToString(cc_file_name, '@@BASE_CLASSES@@', base_classes)
            base.StringToString(cc_file_name, '@@CODE_CONS@@', code_cons)
            base.StringToString(cc_file_name, '@@CODE_DES@@', code_des)
            base.StringToString(cc_file_name, '@@METHODS@@', methods)
